/* A Bison parser, made from bac.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	UNSIGNED_INT	257
# define	STRING	258
# define	RAWSTRING	259
# define	STRINGCONCAT	260
# define	STRINGCOMPARE	261
# define	STRINGCOPY	262
# define	STRINGLENGTH	263
# define	IDENTIFIER	264
# define	CHARCON	265
# define	INCLUDE	266
# define	FNSTRING	267
# define	NE	268
# define	LE	269
# define	GE	270
# define	EQ	271
# define	OR	272
# define	AND	273
# define	PLPL	274
# define	MIMI	275
# define	IF	276
# define	ELSE	277
# define	SWITCH	278
# define	CASE	279
# define	DEFAULT	280
# define	WHILE	281
# define	DO	282
# define	FOR	283
# define	CBEGIN	284
# define	CONST	285
# define	TYPEDEF	286
# define	VOID	287
# define	INT	288
# define	CHAR	289
# define	CONTINUE	290
# define	BREAK	291
# define	RETURN	292
# define	COUT	293
# define	LTLT	294
# define	ENDL	295
# define	CIN	296
# define	GTGT	297
# define	MAIN	298
# define	MONITOR	299
# define	INIT	300
# define	ATOMIC	301
# define	SEND	302
# define	RECEIVE	303
# define	BROADCAST	304
# define	EXTERN	305
# define	SSCANF	306
# define	SPRINTF	307
# define	LOWER_THAN_ELSE	308

#line 1 "bac.y"

       /* yacc grammar for BenAri Concurrent C */
       /* based on the grammar for the BenAri Concurrent Pascal compiler */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <assert.h>

#include "../include/bacicnty.h"
#include "../include/globdata.h"
#include "../include/globtabs.h"
#include "../include/genutil.h"
#include "../include/compdata.h"
#include "../include/computil.h"
#include "../include/incfiles.h"
#include "../include/pcode.h"

extern   int   yydebug;
extern   char  yytext[];
extern   char  numbertext[80];
extern   int   numberbase;
extern   char  laststring[];
extern   char  lasttoken[];
extern   void  global_init(int argc, char** argv);
extern   char  *lastident();

extern   int fprintf(FILE*,const char*,...);
extern   int printf(const char*,...);
extern   int free(void*);
extern   void yyerror(char*); 
extern   int yylex(void); 

void process_breaks();
void process_continues();
void process_returns();

void process_var_inits(int level);
void add_var_init(int* curr_var, int tix, int level, int value);

#define YYDEBUG 1

char  comp_tail[] = {"C-- to PCODE Compiler, "};
extern char  comp_date[];

char  source_suffix[] = {".cm"};
char  list_suffix[] = {".lst"};

BUFFER   pbuf;   /* string buffer for parsing */
/* constants for passing synthesized information back up the parse tree */
int   dx,level=0;
/* for passing type of constant back to constant productions */
TYPES consttype;
/* for passing back information to productions using 'type' prod */

#define NO_EXPR -1
   /* to pass up the parse tree when no entry in the expr array has */
   /* been generated                                                */

int   array_defined;

#define MAXARNEST 50    /* max nesting in array declarations */
struct {
   int aref;         /* atab index */
   TYPES  eltyp;     /* element type for this atab index */
} arstack[MAXARNEST];
int   topars = -1;   /* index of top item on arstack */
int   last_aref;     /* for calculating array references */
TYPES last_eltyp;

#define MAXPFNEST 50    /* max nesting in function calls */
struct {
   int   pct;     /* parm count for this call */
   int   tix;     /* tab index for this proc or function */
} pfstack[MAXPFNEST];
int   toppfs = -1;   /* index of top item on pfstack */
int   last_pfv;   /* tab index of last proc func or variable ref */
int   last_pf;    /* tab index of last proc or func ref */
int   parmct;     /* count of parms in a proc or func call */
int   prt;        /* tab index of current proc */

int   in_cobegin = 0;  /* 1 when in COBEGIN-COEND block */

int   in_include = 0;  /* to signal yylex to change its tactics */

int   by_value;      /* 0 for pass-by-reference parameters, 1 by-value */

int   main_declared = 0;  /* 1 when main proc is declared */

int   making_objfile = 0;  /* 0 unless -c option is used, then 1 */


int   elem_size;     /* size in stack words of variable being declared */
TYPES elem_typ;      /* type of variable being declared */
int   elem_ref;      /* ref value of variable being declared */
int   elem_tix;      /* tab index of type, when it has one */
int   curr_parm_offset;  /* offset to parms in stack frame of curr func */
int   delta_vsize;   /* change in vize parm in a func block due to parms */

int   assign_cnt = 0;   /* for handling multiple assignments */

TYPES formal_type;      /* holds typ field of formal parms */

int   in_func_decl;     /* 1 if declaring a function, 0 otherwise */
int   void_function;    /* 1 if function has VOID return type, 0 otherwise */
int   func_tab;         /* tab index of function being declared */

#define MAXBREAK  200   
   /* max # breaks in a nest of loop and switch stmts */
#define MAXBRNEST  20   
   /* max depth of the nesting */
int   break_loc[MAXBREAK]; /* loc of 'break' instr */
   /* each 'break' instruction generates a JUMP PCODE instruction.  */
   /* The target of this jump has to be filled in, once it is known.*/
   /* break_loc[curr_break] holds the lc in the 'code' array of the */
   /* JUMP instr of the current break instruction being parsed.     */
   /* For both switch and loop statement, the 'break' instruction   */
   /* generates a JUMP out of the loop or switch.  The action is    */
   /* the same for either an enclosing switch or loop block.        */
int   curr_break = -1;  
   /* index of top of 'break_loc' array */

#define MAXCONT   200   
   /* max # continues in a nest of loop stmts */
int   cont_loc[MAXCONT]; 
   /* each 'continue' instruction generates a JUMP PCODE instr.     */
   /* The target of this jump is always known, but we use the same  */
   /* machinery as is used in the 'break' statement, because cont's */
   /* can occur any any loop, and loops can be nested arbitrarily.  */
   /* cont_loc[curr_break] holds the lc in the 'code' array of the  */
   /* JUMP instr of the current continue instruction being parsed.  */
int   curr_cont = -1;
   /* index of top of 'cont_loc' array */

enum brk_block_type {loop_blk, switch_blk};
typedef enum brk_block_type break_block_type;

   /* breaks can occur in the switch and loop statements and can be */
   /* nested arbitrarily.  We keep the information about breaks, as */
   /* well as continues, in an array-based implementation of a      */
   /* stack of the following structs, to handle the nesting.        */ 
struct {
   int first_break;
      /* index in the break_loc array of the first break in this */
      /* block, if there is one, or -1, if there is none         */
   int first_cont;
      /* index in the cont_loc array of the first break in this  */
      /* block, if there is one, or -1, if there is none         */
   break_block_type bb_type;
      /* type of this break_block:  loop or switch               */
} break_block[MAXBRNEST];

int break_level = -1;
   /* top of the break_block array */

   /* procs for managing the break blocks */
void enter_break_block(int* break_level, break_block_type bbt);
void leave_break_block(int* break_level, int* curr_break, int* curr_cont);

#define MAXCASELOC  200    /* max # 'case' stmts in a nest of switch stmts */
#define MAXSWNEST  20      /* max depth of the nesting */
int   case_loc[MAXCASELOC];   
   /* Each 'case' stmt in a 'switch' block generates a JZER to the     */
   /* code for the next 'case' stmt in the 'switch'.  That is, if the  */
   /* TEST_EQ instruction that checks the case value fails, then a     */
   /* jump to the next case block must occur.  The target of this JZER */
   /* is not known until the next case block is encountered.           */
int   curr_case = -1;      
   /* index of top of case_loc array */

   /* information used to compile switch statements */
struct {
   int expr_index;
      /* index into expr array of the expression in the switch stmt */
   int first_case;
      /* index in the case_loc array of the first case in this switch */
      /* block, if there is one, or -1, if there is none              */
} switch_block[MAXSWNEST];
int   switch_level = -1;  
  /* index of the top of the switch_block array, 1 less than the      */
  /* switch nesting level */
int   case_hdr_cnt = 0;    /* number of case labels for one code block */ 
int   first_case_hdr = -1; /* case_loc index of first label of a codeblk */

#define MAXFORNEST  20
   /* information used to compile for loops */
struct {
   int   iter_loc;      /* lc of iteration code */
   int   cont_loc;      /* lc of continuation test code */
   int   cont_jzer;     /* lc of JZER of continuation test */
   int   stmt_loc;      /* lc of stmt code */
} for_info[MAXFORNEST];
int   curr_for = -1;    /* top of 'for_info' stack */

#define MAXRETURN  50      /* max # returns in a function */
int   return_loc[MAXRETURN];  /* lc of JUMP stmt at return */
int   curr_ret = -1;

#define MAXVARINIT   100   /* max # of vbls to be initialized */
   /* at present, only monitors need this data structure,     */
   /* because the grammar allows variable declaration and     */
   /* function declaration to be intermixed in the outer      */
   /* level of the monitor.  The actual intialization has to  */
   /* be postponed until the monitor init code is generated.  */
   /* The var_init list is never shortened.  The lev field of */
   /* a variable is set to -1 after it's initialized.         */
struct {
   int   value;         /* value of the variable */        
   int   lev;           /* level of the variable  */
   int   tix;           /* tab index of the variable */ 
}var_init[MAXVARINIT];
int   curr_var = -1;

int   in_mon_decl;      /* 1 if in a monitor declaration, else 0 */

int   char_loc;   /* tab index of char declaration */
int   int_loc;    /* tab index of int declaration */

extern int last_predeclared;  /* tab index of last predeclared id */

int   ob_tix;           /* tab index of outer block */ 
int   outer_call_lc;;   /* lc of outer block SHORTCALL */


int   extern_decl = 0;  /* 1 if in an extern declaration, else 0 */


int   in_typedef = 0;   /* 1 if in an array typedef, 0 otherwise */

int  varargs_cnt;       /* to count the number of args in a varargs call */
                        /* e.g., sprintf, sscanf                         */

#define emit_push_addr(x)  (\
emit2(((x).normal ? LOAD_ADDR : LOAD_VALUE), (x).lev, (x).adr))


#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		437
#define	YYFLAG		-32768
#define	YYNTBASE	75

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 308 ? yytranslate[x] : 218)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    74,     2,    55,     2,    73,    61,     2,
      56,    57,    71,    67,    60,    66,     2,    72,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    68,    62,
      69,    65,    70,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    63,     2,    64,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    58,     2,    59,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     4,     7,     8,    10,    13,    15,    17,    19,
      21,    23,    25,    27,    30,    33,    34,    37,    42,    43,
      45,    47,    52,    56,    59,    62,    64,    67,    69,    71,
      74,    78,    82,    84,    88,    89,    91,    93,    95,    99,
     102,   104,   107,   109,   114,   117,   120,   122,   125,   127,
     129,   131,   132,   137,   139,   144,   147,   151,   153,   156,
     158,   160,   164,   166,   168,   173,   175,   177,   181,   183,
     187,   189,   192,   194,   197,   201,   206,   211,   213,   220,
     222,   225,   228,   230,   232,   234,   236,   238,   240,   242,
     244,   248,   250,   253,   256,   259,   261,   264,   267,   270,
     271,   273,   275,   279,   281,   283,   285,   287,   289,   291,
     293,   295,   297,   299,   301,   303,   305,   307,   309,   316,
     319,   322,   325,   330,   336,   338,   342,   345,   350,   356,
     361,   363,   365,   370,   372,   375,   379,   381,   384,   389,
     390,   391,   392,   395,   398,   403,   407,   414,   421,   423,
     427,   429,   430,   432,   436,   440,   443,   444,   446,   448,
     449,   451,   453,   456,   459,   463,   465,   469,   472,   476,
     478,   480,   482,   487,   489,   490,   492,   495,   497,   499,
     502,   505,   508,   511,   513,   517,   519,   521,   525,   527,
     529,   533,   535,   537,   539,   541,   543,   545,   547,   549,
     552,   555,   559,   561,   563,   565,   567,   571,   573,   575,
     577,   579,   581,   583,   585,   589,   592,   594,   597,   600,
     603,   606,   608,   610,   612,   614,   617,   619,   621,   623,
     626,   630,   634,   636,   638,   640,   642,   644,   646,   648,
     652,   656,   660,   662,   666,   670,   673,   677,   681,   686,
     692,   694,   698,   702,   708,   711,   713,   718,   722,   727,
     729
};
static const short yyrhs[] =
{
      76,    77,    81,     0,    76,    81,     0,     0,    78,     0,
      77,    78,     0,    79,     0,    85,     0,    96,     0,   114,
       0,   116,     0,   107,     0,   120,     0,    80,    13,     0,
      55,    12,     0,     0,    82,    84,     0,    83,    44,    56,
      57,     0,     0,    34,     0,    33,     0,    58,   105,   126,
      59,     0,    58,   126,    59,     0,    58,    59,     0,    86,
      84,     0,    87,     0,    47,    87,     0,    88,     0,    89,
       0,    90,    91,     0,    33,    90,    91,     0,   108,    90,
      91,     0,    10,     0,    56,    92,    57,     0,     0,    33,
       0,    93,     0,    94,     0,    93,    60,    94,     0,    95,
     217,     0,   108,     0,   108,    61,     0,     4,     0,    97,
      58,    98,    59,     0,    45,   217,     0,    99,   101,     0,
     100,     0,    99,   100,     0,    85,     0,   116,     0,   107,
       0,     0,   102,    58,   126,    59,     0,    46,     0,    97,
      58,   104,    59,     0,    86,    62,     0,   104,    86,    62,
       0,   106,     0,   105,   106,     0,   107,     0,   120,     0,
     108,   109,    62,     0,    34,     0,    35,     0,     4,    63,
     118,    64,     0,   216,     0,   110,     0,   109,    60,   110,
       0,   217,     0,   217,    65,   117,     0,   111,     0,   217,
     112,     0,   113,     0,   112,   113,     0,    63,   118,    64,
       0,   115,   108,   217,    62,     0,   115,   108,   111,    62,
       0,    32,     0,    31,   108,   217,    65,   117,    62,     0,
     118,     0,    66,   118,     0,    67,   118,     0,    11,     0,
     119,     0,   216,     0,     3,     0,   121,     0,   123,     0,
     124,     0,   125,     0,   122,    86,    62,     0,    51,     0,
     122,   107,     0,   122,   111,     0,   122,   103,     0,   129,
       0,   126,   129,     0,     1,    62,     0,     1,    59,     0,
       0,   128,     0,   175,     0,   128,    60,   175,     0,   137,
       0,    84,     0,   150,     0,   151,     0,   174,     0,   164,
       0,   165,     0,   166,     0,   168,     0,   171,     0,   172,
       0,   130,     0,   131,     0,   133,     0,   134,     0,    48,
     132,    60,   175,    57,    62,     0,    56,   203,     0,    56,
     175,     0,    50,   207,     0,   135,    60,   136,    57,     0,
      53,    56,   175,    60,   203,     0,   175,     0,   136,    60,
     175,     0,   138,   139,     0,   138,   139,   140,   129,     0,
     141,    58,   142,   148,    59,     0,    22,    56,   175,    57,
       0,   129,     0,    23,     0,    24,    56,   175,    57,     0,
     143,     0,   142,   143,     0,   144,   147,   126,     0,   145,
       0,   144,   145,     0,    25,   146,   175,    68,     0,     0,
       0,     0,   149,   126,     0,    26,    68,     0,   163,    58,
     126,    59,     0,   152,   153,   129,     0,   154,   155,   129,
     156,   157,    62,     0,   158,   160,   161,   162,    57,   129,
       0,    27,     0,    56,   175,    57,     0,    28,     0,     0,
      27,     0,    56,   175,    57,     0,   159,   127,    62,     0,
      29,    56,     0,     0,   175,     0,    62,     0,     0,   128,
       0,    30,     0,    36,    62,     0,    37,    62,     0,   167,
     173,    62,     0,    38,     0,    39,   169,    62,     0,    40,
     170,     0,   169,    40,   170,     0,   175,     0,    41,     0,
       5,     0,    42,    43,   175,    62,     0,    62,     0,     0,
     175,     0,   175,    62,     0,   179,     0,   176,     0,   177,
     175,     0,   178,   175,     0,   216,    65,     0,   212,    65,
       0,   181,     0,   180,    18,   181,     0,   179,     0,   183,
       0,   182,    19,   183,     0,   181,     0,   186,     0,   184,
     185,   186,     0,   186,     0,    17,     0,    69,     0,    70,
       0,    15,     0,    16,     0,    14,     0,   189,     0,    67,
     189,     0,    66,   189,     0,   187,   188,   189,     0,   186,
       0,    67,     0,    66,     0,   192,     0,   190,   191,   192,
       0,   189,     0,    71,     0,    72,     0,    73,     0,   193,
       0,   119,     0,    11,     0,    56,   175,    57,     0,    74,
     192,     0,   194,     0,   194,    20,     0,    20,   194,     0,
     194,    21,     0,    21,   194,     0,   195,     0,   212,     0,
     215,     0,   216,     0,   196,   197,     0,   200,     0,   211,
       0,   216,     0,    56,    57,     0,    56,   198,    57,     0,
     198,    60,   199,     0,   199,     0,   175,     0,   201,     0,
     204,     0,   205,     0,   206,     0,   208,     0,     6,   132,
     202,     0,    60,   175,    57,     0,    60,   203,    57,     0,
       5,     0,     8,   132,   202,     0,     7,   132,   202,     0,
       9,   207,     0,    56,   175,    57,     0,    56,     5,    57,
       0,   209,    60,   210,    57,     0,    52,    56,   175,    60,
     203,     0,   175,     0,   210,    60,   175,     0,    49,   132,
      57,     0,    49,   132,    60,   175,    57,     0,   213,   214,
       0,   216,     0,   214,    63,   175,    64,     0,    63,   175,
      64,     0,    34,    56,   175,    57,     0,    10,     0,    10,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   260,   267,   276,   292,   293,   296,   297,   298,   299,
     300,   301,   302,   305,   316,   320,   333,   356,   372,   373,
     375,   378,   379,   380,   383,   405,   407,   411,   417,   425,
     434,   441,   457,   477,   481,   482,   483,   486,   487,   490,
     505,   507,   509,   520,   527,   543,   546,   547,   550,   551,
     552,   555,   565,   575,   582,   591,   593,   597,   598,   601,
     602,   609,   612,   619,   626,   636,   649,   650,   653,   661,
     697,   701,   734,   736,   739,   756,   767,   782,   786,   798,
     800,   802,   804,   808,   810,   819,   823,   824,   825,   826,
     829,   837,   841,   845,   852,   856,   857,   858,   860,   865,
     867,   870,   871,   874,   875,   876,   877,   884,   885,   886,
     887,   888,   889,   890,   891,   894,   895,   896,   899,   926,
     928,   943,   957,   965,   976,   988,  1002,  1004,  1006,  1024,
    1028,  1032,  1036,  1050,  1051,  1054,  1057,  1059,  1063,  1083,
    1092,  1103,  1105,  1108,  1112,  1116,  1122,  1127,  1154,  1161,
    1170,  1176,  1180,  1184,  1194,  1200,  1213,  1215,  1225,  1232,
    1237,  1246,  1258,  1278,  1297,  1319,  1328,  1331,  1332,  1335,
    1351,  1353,  1360,  1375,  1377,  1379,  1382,  1390,  1391,  1394,
    1415,  1438,  1452,  1456,  1457,  1471,  1475,  1476,  1490,  1494,
    1495,  1512,  1516,  1517,  1518,  1519,  1520,  1521,  1524,  1525,
    1534,  1545,  1562,  1566,  1567,  1570,  1571,  1592,  1596,  1597,
    1598,  1601,  1602,  1610,  1618,  1620,  1633,  1634,  1646,  1658,
    1670,  1682,  1683,  1684,  1687,  1700,  1745,  1746,  1749,  1773,
    1774,  1777,  1778,  1781,  1792,  1793,  1794,  1795,  1796,  1799,
    1812,  1825,  1829,  1841,  1854,  1873,  1892,  1903,  1915,  1930,
    1941,  1950,  1961,  1975,  2000,  2013,  2043,  2053,  2065,  2072,
    2076
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "UNSIGNED_INT", "STRING", "RAWSTRING", 
  "STRINGCONCAT", "STRINGCOMPARE", "STRINGCOPY", "STRINGLENGTH", 
  "IDENTIFIER", "CHARCON", "INCLUDE", "FNSTRING", "NE", "LE", "GE", "EQ", 
  "OR", "AND", "PLPL", "MIMI", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT", 
  "WHILE", "DO", "FOR", "CBEGIN", "CONST", "TYPEDEF", "VOID", "INT", 
  "CHAR", "CONTINUE", "BREAK", "RETURN", "COUT", "LTLT", "ENDL", "CIN", 
  "GTGT", "MAIN", "MONITOR", "INIT", "ATOMIC", "SEND", "RECEIVE", 
  "BROADCAST", "EXTERN", "SSCANF", "SPRINTF", "LOWER_THAN_ELSE", "'#'", 
  "'('", "')'", "'{'", "'}'", "','", "'&'", "';'", "'['", "']'", "'='", 
  "'-'", "'+'", "':'", "'<'", "'>'", "'*'", "'/'", "'%'", "'!'", 
  "program", "init_outerscope", "outer_decls", "outer_decl", 
  "include_decl", "start_include", "opt_main_decl", "main_hdr", 
  "opt_main_type", "compound_stmt", "function_decl", "func_proto", 
  "func_hdr", "untyped_func_hdr", "typed_func_hdr", "function_id", 
  "formal_params", "param_list", "param_groups", "param_group", 
  "param_typespec", "monitor_decl", "monitor_hdr", "mon_internal_decls", 
  "internal_decls", "internal_decl", "monitor_init", "the_init", 
  "extern_mon_spec", "mon_func_protos", "var_ext_decls", "var_ext_decl", 
  "var_decl", "var_typespec", "var_list", "var_name", "array_decl", 
  "index_list", "index", "type_decl", "the_typedef", "const_decl", 
  "constant", "unsigned_const", "unsigned_num", "extern_decl", 
  "extern_func_decl", "the_extern", "extern_var_decl", 
  "extern_array_decl", "extern_mon_decl", "stmt_list", 
  "opt_for_expr_list", "for_expr_list", "stmt", "special_proc_calls", 
  "send_call", "left_exprparm", "broadcast_call", "sprintf_call", 
  "sprintf_buf_fmt", "sprintf_parmlist", "selection_stmt", "if_expr", 
  "then_stmt", "the_else", "switch_hdr", "case_groups", "case_group", 
  "case_hdr_list", "case_hdr", "begin_case", "patch_case_hdrs", 
  "opt_default", "the_default", "cobegin_stmt", "iteration_stmt", 
  "the_while", "while_expr", "the_do", "do_stmt_loc", "the_do_while", 
  "do_while_expr", "for_init", "the_for", "opt_continue_expr", 
  "for_semic2", "opt_iter_exprs", "cbegin", "continue_stmt", "break_stmt", 
  "return_stmt", "the_return", "output_stmt", "output_list", 
  "output_item", "input_stmt", "null_stmt", "opt_expr", "expr_stmt", 
  "expr", "var_assign", "id_becomes", "array_var_becomes", 
  "logical_or_expr", "left_logical_or_expr", "logical_and_expr", 
  "left_logical_and_expr", "relational_expr", "left_relational_expr", 
  "relational_op", "simple_expr", "left_simple_expr", "add_op", "term", 
  "left_term", "mult_op", "factor", "variable", "var_ident", "func_call", 
  "func_id", "actual_params", "actuals_list", "actual_param", 
  "stringfn_call", "stringconcat_call", "right_stringparm", 
  "rawstring_parm", "stringcopy_call", "stringcompare_call", 
  "stringlength_call", "single_exprparm", "sscanf_call", "sscanf_buf_fmt", 
  "sscanf_parmlist", "receive_call", "array_var", "array_id", 
  "index_expr", "typecast", "ident", "newident", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    75,    75,    76,    77,    77,    78,    78,    78,    78,
      78,    78,    78,    79,    80,    81,    81,    82,    83,    83,
      83,    84,    84,    84,    85,    86,    86,    87,    87,    88,
      89,    89,    90,    91,    92,    92,    92,    93,    93,    94,
      95,    95,    95,    96,    97,    98,    99,    99,   100,   100,
     100,   101,   101,   102,   103,   104,   104,   105,   105,   106,
     106,   107,   108,   108,   108,   108,   109,   109,   110,   110,
     110,   111,   112,   112,   113,   114,   114,   115,   116,   117,
     117,   117,   117,   118,   118,   119,   120,   120,   120,   120,
     121,   122,   123,   124,   125,   126,   126,   126,   126,   127,
     127,   128,   128,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   130,   130,   130,   131,   132,
     132,   133,   134,   135,   136,   136,   137,   137,   137,   138,
     139,   140,   141,   142,   142,   143,   144,   144,   145,   146,
     147,   148,   148,   149,   150,   151,   151,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   160,   161,   162,
     162,   163,   164,   165,   166,   167,   168,   169,   169,   170,
     170,   170,   171,   172,   173,   173,   174,   175,   175,   176,
     176,   177,   178,   179,   179,   180,   181,   181,   182,   183,
     183,   184,   185,   185,   185,   185,   185,   185,   186,   186,
     186,   186,   187,   188,   188,   189,   189,   190,   191,   191,
     191,   192,   192,   192,   192,   192,   193,   193,   193,   193,
     193,   193,   193,   193,   194,   195,   195,   195,   196,   197,
     197,   198,   198,   199,   200,   200,   200,   200,   200,   201,
     202,   202,   203,   204,   205,   206,   207,   207,   208,   209,
     210,   210,   211,   211,   212,   213,   214,   214,   215,   216,
     217
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     3,     2,     0,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     2,     4,     0,     1,
       1,     4,     3,     2,     2,     1,     2,     1,     1,     2,
       3,     3,     1,     3,     0,     1,     1,     1,     3,     2,
       1,     2,     1,     4,     2,     2,     1,     2,     1,     1,
       1,     0,     4,     1,     4,     2,     3,     1,     2,     1,
       1,     3,     1,     1,     4,     1,     1,     3,     1,     3,
       1,     2,     1,     2,     3,     4,     4,     1,     6,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     2,     2,     1,     2,     2,     2,     0,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     2,
       2,     2,     4,     5,     1,     3,     2,     4,     5,     4,
       1,     1,     4,     1,     2,     3,     1,     2,     4,     0,
       0,     0,     2,     2,     4,     3,     6,     6,     1,     3,
       1,     0,     1,     3,     3,     2,     0,     1,     1,     0,
       1,     1,     2,     2,     3,     1,     3,     2,     3,     1,
       1,     1,     4,     1,     0,     1,     2,     1,     1,     2,
       2,     2,     2,     1,     3,     1,     1,     3,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     3,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     1,     3,     3,     2,     3,     3,     4,     5,
       1,     3,     3,     5,     2,     1,     4,     3,     4,     1,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       3,    15,     0,    32,     0,    77,    20,    19,    63,     0,
       0,    91,     0,    15,     4,     6,     0,     2,     0,     0,
       7,     0,    25,    27,    28,     0,     8,     0,    11,     0,
       9,     0,    10,    12,    86,     0,    87,    88,    89,    65,
       0,   259,    62,     0,    32,     0,   260,    44,     0,    26,
       0,    14,     5,     1,    13,     0,    16,     0,    24,    34,
      29,     0,   260,     0,     0,    66,    70,    68,     0,    32,
       0,     0,    94,    92,    93,     0,    85,     0,    83,    84,
       0,    30,     0,     0,     0,     0,     0,   213,     0,     0,
       0,     0,   148,   150,     0,   161,    62,     0,     0,   165,
       0,     0,     0,     0,     0,     0,     0,     0,    23,   173,
       0,     0,     0,   104,     0,    57,    59,     0,   212,    60,
       0,    95,   114,   115,   116,   117,     0,   103,     0,     0,
     105,   106,     0,   151,   156,    99,     0,   108,   109,   110,
     174,   111,   112,   113,   107,     0,   178,     0,     0,   177,
       0,   183,     0,   186,     0,   189,     0,   198,     0,   205,
     211,   216,   221,     0,   226,   234,   235,   236,   237,   238,
       0,   227,   222,     0,   223,   224,     0,    42,    35,     0,
      36,    37,     0,    40,    48,     0,    51,    46,    50,    49,
      31,     0,    61,     0,     0,    71,    72,     0,     0,    90,
       0,    64,     0,    98,    97,     0,     0,     0,     0,     0,
     245,   218,   224,   220,     0,     0,   155,     0,   162,   163,
       0,     0,     0,     0,     0,   121,     0,     0,     0,     0,
     224,   200,   222,   224,   199,   215,    58,     0,    22,    96,
       0,   130,   126,     0,     0,     0,     0,     0,   157,     0,
     100,   101,     0,     0,   175,   176,   179,   180,     0,     0,
     197,   195,   196,   192,   193,   194,     0,   204,   203,     0,
     208,   209,   210,     0,   217,   219,     0,   225,     0,   182,
       0,   254,   181,    17,    33,     0,    39,    41,    43,    53,
      47,    45,     0,    67,     0,    82,     0,     0,    69,    79,
      73,    76,    75,     0,     0,     0,   242,   120,   119,     0,
     239,   244,   243,     0,     0,     0,     0,     0,   171,   170,
     167,   169,     0,   166,     0,     0,   252,     0,     0,     0,
     214,    21,     0,   124,   131,     0,   139,   141,   133,   140,
     136,     0,   145,     0,   158,   159,   154,     0,     0,   164,
     184,   187,   190,   201,   206,   229,   233,     0,   232,   250,
       0,     0,     0,    38,     0,    74,    80,    81,    55,    54,
       0,    78,     0,     0,   247,   246,   129,   132,   258,   168,
     172,     0,     0,     0,     0,   122,     0,   127,     0,     0,
     134,     0,     0,   137,     0,   149,   152,     0,   160,     0,
     102,   144,   230,     0,   248,     0,   257,     0,     0,    56,
     240,   241,     0,   253,   249,   123,   125,     0,   143,   128,
     142,   135,     0,     0,     0,   231,   251,   256,    52,   118,
     138,     0,   146,   147,   153,     0,     0,     0
};

static const short yydefgoto[] =
{
     435,     1,    13,    14,    15,    16,    17,    18,    19,   113,
      20,    21,    22,    23,    24,    25,    60,   179,   180,   181,
     182,    26,    27,   185,   186,   187,   291,   292,    72,   304,
     114,   115,    28,    29,    64,    65,    66,   195,   196,    30,
      31,    32,   298,   299,   118,    33,    34,    35,    36,    37,
      38,   120,   249,   250,   121,   122,   123,   206,   124,   125,
     126,   332,   127,   128,   242,   335,   129,   337,   338,   339,
     340,   388,   394,   391,   392,   130,   131,   132,   245,   133,
     246,   397,   423,   134,   135,   247,   345,   399,   136,   137,
     138,   139,   140,   141,   221,   320,   142,   143,   253,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     266,   155,   156,   269,   157,   158,   273,   159,   160,   161,
     162,   163,   277,   357,   358,   164,   165,   310,   308,   166,
     167,   168,   210,   169,   170,   360,   171,   172,   173,   281,
     174,   230,    67
};

static const short yypact[] =
{
  -32768,  1019,   -40,    20,   223,-32768,    43,    54,-32768,    64,
      58,-32768,    72,  1019,-32768,-32768,    82,-32768,    41,    68,
  -32768,    41,-32768,-32768,-32768,    91,-32768,    70,-32768,   145,
  -32768,   223,-32768,-32768,-32768,   178,-32768,-32768,-32768,-32768,
      15,-32768,-32768,    64,-32768,    91,-32768,-32768,    43,-32768,
      43,-32768,-32768,-32768,-32768,   321,-32768,   103,-32768,   235,
  -32768,   170,   107,    91,    44,-32768,-32768,    71,    64,    16,
     110,   141,-32768,-32768,-32768,   144,-32768,   150,-32768,-32768,
     154,-32768,   -30,   168,   168,   168,   172,-32768,   216,   216,
     181,   193,-32768,-32768,   195,-32768,   197,   192,   201,-32768,
     194,   224,   168,   168,   172,   218,   219,   972,-32768,-32768,
     991,   991,   991,-32768,   390,-32768,-32768,    64,-32768,-32768,
     514,-32768,-32768,-32768,-32768,-32768,   217,-32768,   762,   222,
  -32768,-32768,   220,-32768,   972,   972,   225,-32768,-32768,-32768,
     972,-32768,-32768,-32768,-32768,   226,-32768,   972,   972,   264,
     269,   271,   272,-32768,    31,    55,    84,   124,   159,-32768,
  -32768,    96,-32768,   236,-32768,-32768,-32768,-32768,-32768,-32768,
     233,-32768,   229,   232,-32768,    10,   240,   -40,-32768,   242,
     243,-32768,    64,   239,-32768,   247,   175,-32768,-32768,-32768,
  -32768,    64,-32768,    15,    11,   144,-32768,   245,   114,-32768,
     231,-32768,    11,-32768,-32768,   851,   250,   250,   250,   921,
  -32768,-32768,-32768,-32768,   972,   972,-32768,   972,-32768,-32768,
     832,     3,   972,   251,    26,-32768,   972,   972,   197,   255,
      -7,   124,-32768,    33,   124,-32768,-32768,   576,-32768,-32768,
     972,-32768,   290,   289,   972,   762,   762,   256,-32768,   258,
     257,-32768,   452,   259,-32768,-32768,-32768,-32768,   972,   972,
  -32768,-32768,-32768,-32768,-32768,-32768,   972,-32768,-32768,   991,
  -32768,-32768,-32768,   991,-32768,-32768,   902,-32768,   972,-32768,
     972,   263,-32768,-32768,-32768,   238,-32768,-32768,-32768,-32768,
  -32768,-32768,   275,-32768,   270,-32768,    15,    15,-32768,-32768,
  -32768,-32768,-32768,   274,   119,   276,-32768,-32768,-32768,   851,
  -32768,-32768,-32768,   280,   282,   283,   287,   295,-32768,-32768,
  -32768,-32768,   832,-32768,   291,   972,-32768,   972,   301,   302,
  -32768,-32768,    37,-32768,-32768,   762,-32768,   161,-32768,   289,
  -32768,   307,-32768,   338,-32768,   972,-32768,   972,   638,-32768,
     271,-32768,   123,   124,-32768,-32768,-32768,    75,-32768,-32768,
      85,   303,   972,-32768,   452,-32768,-32768,-32768,-32768,-32768,
     304,-32768,   311,   318,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   319,   324,   373,   373,-32768,   972,-32768,   972,   314,
  -32768,   325,   452,-32768,   452,-32768,-32768,   329,   257,   332,
  -32768,-32768,-32768,   972,-32768,   972,-32768,   322,   700,-32768,
  -32768,-32768,   328,-32768,-32768,-32768,-32768,   334,-32768,-32768,
     762,   762,   972,   330,   762,-32768,-32768,-32768,-32768,-32768,
  -32768,   346,-32768,-32768,-32768,   404,   405,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,   393,-32768,-32768,   394,-32768,-32768,   125,
     -46,   -33,   398,-32768,-32768,    32,    -6,-32768,-32768,   128,
  -32768,-32768,   374,-32768,-32768,   230,-32768,-32768,-32768,-32768,
  -32768,   308,   -11,     0,-32768,   244,   -16,-32768,   228,-32768,
  -32768,   -45,   213,   -35,   -37,   -38,-32768,-32768,-32768,-32768,
  -32768,  -108,-32768,    76,  -119,-32768,-32768,    46,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    93,-32768,
      92,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,   111,-32768,-32768,-32768,-32768,
    -107,-32768,-32768,-32768,-32768,-32768,   176,-32768,   177,-32768,
  -32768,   171,-32768,-32768,   -99,-32768,-32768,  -105,-32768,   104,
  -32768,-32768,-32768,-32768,    42,-32768,-32768,    39,  -296,-32768,
  -32768,-32768,   340,-32768,-32768,-32768,-32768,   -75,-32768,-32768,
  -32768,    50,    -1
};


#define	YYLAST		1074


static const short yytable[] =
{
     229,   239,    70,    78,    43,    77,   237,   235,    47,   241,
      50,   231,   234,   373,    76,   184,   189,   119,    76,    74,
     -65,    41,   295,    40,    73,    41,  -259,   248,   251,   203,
    -259,    68,   204,   254,    75,   232,   232,   232,    45,    81,
     256,   257,    80,   322,   116,   260,   261,   262,   263,  -228,
     188,    39,   197,    44,    39,   117,  -255,   190,   282,   183,
      39,    63,     2,    39,   -62,   323,  -228,   198,     3,  -191,
    -191,  -191,  -191,  -255,    46,   282,   119,   296,   297,  -260,
      45,    39,    63,   326,    51,    39,   327,   414,   415,  -228,
      79,    48,    42,     8,   385,    54,  -255,   386,   307,    55,
     264,   265,   314,   116,   191,   175,   192,   315,   316,    39,
     317,    39,    57,   321,   117,   324,   274,   275,   239,   328,
     329,  -202,  -202,     2,  -191,  -191,   342,   343,    61,     3,
     207,   208,   402,   333,   193,   403,   194,   341,   212,   212,
     184,   189,   404,    56,   348,   405,    58,    59,   223,   224,
     267,   268,    48,    42,     8,    62,    78,    78,   294,   176,
     233,   233,   233,   -32,   175,    78,    10,   303,   354,   356,
     353,   359,   199,   361,     2,   188,   302,   193,   369,     2,
       3,   286,     2,   232,   232,     3,   336,   389,    69,  -202,
    -202,   232,   211,   213,   232,  -207,  -207,  -207,   232,   200,
      50,     4,   372,    48,    42,     8,     4,   193,    48,    42,
       8,    48,    42,     8,   201,   321,   387,    10,   381,   202,
     382,   289,    10,     9,   205,    10,    41,     2,   209,   239,
     270,   271,   272,    41,   220,     2,    39,   214,   251,   177,
     400,     3,   177,    79,    79,    41,   311,   312,    41,   215,
      39,   216,    79,   217,   218,   407,   408,    42,     8,    78,
      78,   366,   367,   219,    48,    42,     8,   222,   178,    42,
       8,   370,    42,     8,   226,   227,   244,   240,    10,   416,
     243,   417,  -185,   252,   420,   183,   421,   258,   255,   239,
    -188,   259,   276,   278,   279,   280,   356,   283,   426,   284,
     287,   239,   239,   285,    50,   433,   288,   301,   233,   233,
     309,   325,   330,   334,   336,   431,   233,   347,   344,   233,
     346,   349,    82,   233,    76,     2,   362,    83,    84,    85,
      86,    41,    87,   364,   365,    39,   368,   374,   371,   375,
     376,    88,    89,    90,   377,    91,    79,    79,    92,    93,
      94,    95,   378,   380,    39,    96,     8,    97,    98,    99,
     100,   383,   384,   101,   395,   396,   409,   406,   410,   102,
     103,   104,    11,   105,   106,   411,   412,   107,   306,    55,
     108,   413,   418,   109,   419,   422,   427,   110,   111,   424,
     429,    82,   432,    76,     2,   112,    83,    84,    85,    86,
      41,    87,   430,   434,   436,   437,    52,    53,    49,    71,
      88,    89,    90,   363,    91,   305,   290,    92,    93,    94,
      95,   398,   236,   300,    96,     8,    97,    98,    99,   100,
     390,   393,   101,   379,   350,   293,   351,   352,   102,   103,
     104,    11,   105,   106,   225,   425,   107,     0,    55,     0,
       0,     0,   109,    82,     0,    76,   110,   111,    83,    84,
      85,    86,    41,    87,   112,     0,     0,     0,     0,     0,
       0,     0,    88,    89,    90,     0,    91,     0,     0,    92,
      93,    94,    95,     0,     0,     0,   228,     0,    97,    98,
      99,   100,     0,     0,   101,     0,     0,     0,     0,     0,
     102,   103,   104,     0,   105,   106,     0,     0,   107,     0,
      55,     0,     0,     0,   109,     0,     0,    76,   110,   111,
      83,    84,    85,    86,    41,    87,   112,     0,     0,     0,
       0,     0,     0,     0,    88,    89,    90,     0,    91,     0,
       0,    92,    93,    94,    95,     0,     0,     0,   228,     0,
      97,    98,    99,   100,     0,     0,   101,     0,     0,     0,
       0,     0,   102,   103,   104,     0,   105,   106,     0,     0,
     107,     0,    55,   238,     0,     0,   109,     0,     0,    76,
     110,   111,    83,    84,    85,    86,    41,    87,   112,     0,
       0,     0,     0,     0,     0,     0,    88,    89,    90,     0,
      91,     0,     0,    92,    93,    94,    95,     0,     0,     0,
     228,     0,    97,    98,    99,   100,     0,     0,   101,     0,
       0,     0,     0,     0,   102,   103,   104,     0,   105,   106,
       0,     0,   107,     0,    55,   331,     0,     0,   109,     0,
       0,    76,   110,   111,    83,    84,    85,    86,    41,    87,
     112,     0,     0,     0,     0,     0,     0,     0,    88,    89,
      90,     0,    91,     0,     0,    92,    93,    94,    95,     0,
       0,     0,   228,     0,    97,    98,    99,   100,     0,     0,
     101,     0,     0,     0,     0,     0,   102,   103,   104,     0,
     105,   106,     0,     0,   107,     0,    55,   401,     0,     0,
     109,     0,     0,    76,   110,   111,    83,    84,    85,    86,
      41,    87,   112,     0,     0,     0,     0,     0,     0,     0,
      88,    89,    90,     0,    91,     0,     0,    92,    93,    94,
      95,     0,     0,     0,   228,     0,    97,    98,    99,   100,
       0,     0,   101,     0,     0,     0,     0,     0,   102,   103,
     104,     0,   105,   106,     0,     0,   107,     0,    55,   428,
       0,     0,   109,     0,     0,    76,   110,   111,    83,    84,
      85,    86,    41,    87,   112,     0,     0,     0,     0,     0,
       0,     0,    88,    89,    90,     0,    91,     0,     0,    92,
      93,    94,    95,     0,     0,     0,   228,     0,    97,    98,
      99,   100,     0,     0,   101,     0,     0,     0,     0,     0,
     102,   103,   104,     0,   105,   106,     0,     0,   107,     0,
      55,     0,     0,     0,   109,     0,     0,     0,   110,   111,
       0,     0,     0,     0,     0,    76,   112,   318,    83,    84,
      85,    86,    41,    87,     0,     0,     0,     0,     0,     0,
       0,     0,    88,    89,    76,     0,   306,    83,    84,    85,
      86,    41,    87,     0,     0,     0,   228,     0,     0,     0,
       0,    88,    89,   319,     0,     0,     0,     0,     0,     0,
       0,   103,     0,     0,   105,   228,     0,     0,   107,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     103,     0,     0,   105,     0,    76,   112,   107,    83,    84,
      85,    86,    41,    87,     0,     0,     0,   110,   111,     0,
       0,     0,    88,    89,    76,   112,   313,    83,    84,    85,
      86,    41,    87,     0,     0,     0,   228,     0,     0,     0,
       0,    88,    89,     0,     0,     0,     0,     0,     0,     0,
       0,   103,     0,     0,   105,   228,     0,     0,   107,   355,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     103,     0,     0,   105,     0,    76,   112,   107,    83,    84,
      85,    86,    41,    87,     0,     0,     0,   110,   111,     0,
       0,     0,    88,    89,    76,   112,     0,    83,    84,    85,
      86,    41,    87,     0,     0,     0,   228,     0,     0,     0,
       0,    88,    89,     0,     0,     0,     0,     0,     0,     0,
       0,   103,     0,     2,   105,   228,     0,     0,   107,     3,
       0,     0,     0,     0,     0,     0,     0,     0,   110,   111,
     103,     0,     0,   105,     0,     0,   112,   107,     0,     0,
       4,     5,     6,     7,     8,     0,     0,     0,     0,     0,
       0,     0,     0,   -18,     9,   112,    10,     0,     0,     0,
      11,     0,     0,     0,    12
};

static const short yycheck[] =
{
     107,   120,    35,    40,     4,    40,   114,   112,     9,   128,
      10,   110,   111,   309,     3,    61,    61,    55,     3,    35,
      10,    10,    11,    63,    35,    10,    10,   134,   135,    59,
      10,    31,    62,   140,    35,   110,   111,   112,     6,    45,
     147,   148,    43,    40,    55,    14,    15,    16,    17,    56,
      61,     1,    68,    10,     4,    55,    63,    63,    65,    59,
      10,    29,     4,    13,    10,    62,    56,    68,    10,    14,
      15,    16,    17,    63,    10,    65,   114,    66,    67,    63,
      48,    31,    50,    57,    12,    35,    60,   383,   384,    56,
      40,    33,    34,    35,    57,    13,    63,    60,   205,    58,
      69,    70,   209,   114,    60,    55,    62,   214,   215,    59,
     217,    61,    44,   220,   114,   222,    20,    21,   237,   226,
     227,    66,    67,     4,    69,    70,   245,   246,    58,    10,
      84,    85,    57,   240,    63,    60,    65,   244,    88,    89,
     186,   186,    57,    18,   252,    60,    21,    56,   102,   103,
      66,    67,    33,    34,    35,    10,   193,   194,   193,    56,
     110,   111,   112,    56,   114,   202,    47,   200,   273,   276,
     269,   278,    62,   280,     4,   186,    62,    63,    59,     4,
      10,   182,     4,   258,   259,    10,    25,    26,    10,    66,
      67,   266,    88,    89,   269,    71,    72,    73,   273,    58,
     200,    31,   309,    33,    34,    35,    31,    63,    33,    34,
      35,    33,    34,    35,    64,   322,   335,    47,   325,    65,
     327,    46,    47,    45,    56,    47,    10,     4,    56,   348,
      71,    72,    73,    10,    40,     4,   186,    56,   345,     4,
     347,    10,     4,   193,   194,    10,   207,   208,    10,    56,
     200,    56,   202,    56,    62,   362,   364,    34,    35,   296,
     297,   296,   297,    62,    33,    34,    35,    43,    33,    34,
      35,   304,    34,    35,    56,    56,    56,    60,    47,   386,
      58,   388,    18,    58,   392,   285,   394,    18,    62,   408,
      19,    19,    56,    60,    65,    63,   403,    57,   405,    57,
      61,   420,   421,    60,   304,   424,    59,    62,   258,   259,
      60,    60,    57,    23,    25,   422,   266,    60,    62,   269,
      62,    62,     1,   273,     3,     4,    63,     6,     7,     8,
       9,    10,    11,    58,    64,   285,    62,    57,    62,    57,
      57,    20,    21,    22,    57,    24,   296,   297,    27,    28,
      29,    30,    57,    62,   304,    34,    35,    36,    37,    38,
      39,    60,    60,    42,    57,    27,    62,    64,    57,    48,
      49,    50,    51,    52,    53,    57,    57,    56,     5,    58,
      59,    57,    68,    62,    59,    56,    64,    66,    67,    57,
      62,     1,    62,     3,     4,    74,     6,     7,     8,     9,
      10,    11,    68,    57,     0,     0,    13,    13,    10,    35,
      20,    21,    22,   285,    24,   202,   186,    27,    28,    29,
      30,   345,   114,   195,    34,    35,    36,    37,    38,    39,
     337,   339,    42,   322,   258,   191,   259,   266,    48,    49,
      50,    51,    52,    53,   104,   403,    56,    -1,    58,    -1,
      -1,    -1,    62,     1,    -1,     3,    66,    67,     6,     7,
       8,     9,    10,    11,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    -1,    24,    -1,    -1,    27,
      28,    29,    30,    -1,    -1,    -1,    34,    -1,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    -1,    52,    53,    -1,    -1,    56,    -1,
      58,    -1,    -1,    -1,    62,    -1,    -1,     3,    66,    67,
       6,     7,     8,     9,    10,    11,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    -1,    24,    -1,
      -1,    27,    28,    29,    30,    -1,    -1,    -1,    34,    -1,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    -1,    52,    53,    -1,    -1,
      56,    -1,    58,    59,    -1,    -1,    62,    -1,    -1,     3,
      66,    67,     6,     7,     8,     9,    10,    11,    74,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    -1,
      24,    -1,    -1,    27,    28,    29,    30,    -1,    -1,    -1,
      34,    -1,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    -1,    52,    53,
      -1,    -1,    56,    -1,    58,    59,    -1,    -1,    62,    -1,
      -1,     3,    66,    67,     6,     7,     8,     9,    10,    11,
      74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    -1,    24,    -1,    -1,    27,    28,    29,    30,    -1,
      -1,    -1,    34,    -1,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    -1,
      52,    53,    -1,    -1,    56,    -1,    58,    59,    -1,    -1,
      62,    -1,    -1,     3,    66,    67,     6,     7,     8,     9,
      10,    11,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    -1,    24,    -1,    -1,    27,    28,    29,
      30,    -1,    -1,    -1,    34,    -1,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    -1,    52,    53,    -1,    -1,    56,    -1,    58,    59,
      -1,    -1,    62,    -1,    -1,     3,    66,    67,     6,     7,
       8,     9,    10,    11,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    -1,    24,    -1,    -1,    27,
      28,    29,    30,    -1,    -1,    -1,    34,    -1,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    -1,    52,    53,    -1,    -1,    56,    -1,
      58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,
      -1,    -1,    -1,    -1,    -1,     3,    74,     5,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,     3,    -1,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    20,    21,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    34,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      49,    -1,    -1,    52,    -1,     3,    74,    56,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    20,    21,     3,    74,     5,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    34,    -1,    -1,    56,    57,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      49,    -1,    -1,    52,    -1,     3,    74,    56,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    20,    21,     3,    74,    -1,     6,     7,     8,
       9,    10,    11,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,     4,    52,    34,    -1,    -1,    56,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      49,    -1,    -1,    52,    -1,    -1,    74,    56,    -1,    -1,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    45,    74,    47,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    55
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 261 "bac.y"
{ 
            if (!making_objfile&&!main_declared) 
               yyerror("No 'main' function declared");
            if (main_declared)
               emit(SHORTRET);
         }
    break;
case 2:
#line 268 "bac.y"
{ 
            if (!making_objfile&&!main_declared) 
               yyerror("No 'main' function declared");
            if (main_declared)
               emit(SHORTRET);
         }
    break;
case 3:
#line 277 "bac.y"
{ 
            level = 0;
            extern_decl = 0;
            enter(outerblock_name,outerblock,level,level);
            ob_tix = last_tab;
            tab[ob_tix].adr = lc;
            /* initialize the block table index with the outer block*/
            tab[ob_tix].ref = last_btab = 0;
            btab[last_btab].lastpar = 0;
            btab[last_btab].psize = btab[last_btab].vsize = 0;
            /* initialize the static display */
            display[last_btab] = level;
         }
    break;
case 13:
#line 306 "bac.y"
{
            if (strcmp(laststring,infile[curr_infile].fname) == 0) 
               yyerror("Recursive file inclusion");
            else {
               curr_infile = open_infile(laststring,curr_infile);
            }
            in_include = 0;
         }
    break;
case 14:
#line 317 "bac.y"
{ in_include = 1; }
    break;
case 15:
#line 321 "bac.y"
{  int i;
            tab[ob_tix].adr = lc;  /* outerblock entry pt */
            for (i = 0; i <= mon; i++){
               /* don't emit CALL_MONINIT for ext_monitor objects */
               if (tab[mtab[i]].obj == monitor) {
                  emit1(MARKSTACK,mtab[i]-last_predeclared);
                  emit(CALL_MONINIT);
               }
            }
            assert(level == 0);
            process_var_inits(level);
         }
    break;
case 16:
#line 334 "bac.y"
{ 
            int i;
            emit(HALT); 
            btab[tab[yyvsp[-1]].ref].last = last_tab;   /* set last var ref in main */
            /* need to backpatch location of outer block code */
            /* in SHORTCALL instruction                       */
            code[outer_call_lc].y = lc; 
            tab[ob_tix].adr = lc;  /* outerblock entry pt */
            for (i = 0; i <= mon; i++){
               /* don't emit CALL_MONINIT for ext_monitor objects */
               if (tab[mtab[i]].obj == monitor) {
                  emit1(MARKSTACK,mtab[i]-last_predeclared);
                  emit(CALL_MONINIT);
               }
            }
            assert(level == 1);
            process_var_inits(level);
            process_var_inits(level-1);   /* outer block variables, too */
         }
    break;
case 17:
#line 357 "bac.y"
{  
            extern_decl = 0;
            enter("main",mainproc,level,level);
            prt = last_tab;
            enter_block(&last_btab,&level,last_tab);
            btab[last_btab].lastpar = last_tab; /* no parms */
            main_declared = 1;
            yyval = prt;
            btab[0].lastpar = prt;  /* save main's tabix for the interp */
            tab[prt].adr = lc;      /* main pgm entry point */
            outer_call_lc = lc;
            emit(SHORTCALL);  /* will have to backpatch addr later */
         }
    break;
case 19:
#line 374 "bac.y"
{ yyval = int_loc; }
    break;
case 24:
#line 384 "bac.y"
{
            if (main_declared)
               yyerror("main() proc must be last");
            if (void_function) {
               if (tab[yyvsp[-1]].mon) emit(EXITMON);
               emit(EXIT_PROC);
            }
            else {
               if (curr_ret >= 0) 
                  process_returns();
               else
                  yyerror("A non-void function must have at least one RETURN statment");
               if (tab[yyvsp[-1]].mon) emit(EXITMON);
               emit(EXIT_FCN);
            } 
            leave_block(&level);
            in_func_decl = 0;
            curr_ret = -1;
         }
    break;
case 25:
#line 406 "bac.y"
{ tab[yyvsp[0]].atomic = 0; }
    break;
case 26:
#line 408 "bac.y"
{ tab[yyvsp[0]].atomic = 1; yyval = yyvsp[0]; }
    break;
case 27:
#line 412 "bac.y"
{ 
            btab[display[level]].psize = curr_parm_offset;
            btab[display[level]].vsize = curr_parm_offset + delta_vsize;
            in_func_decl = 1;
         }
    break;
case 28:
#line 418 "bac.y"
{ 
            btab[display[level]].psize = curr_parm_offset;
            btab[display[level]].vsize = curr_parm_offset + delta_vsize;
            in_func_decl = 1;
         }
    break;
case 29:
#line 426 "bac.y"
{ 
            tab[yyvsp[-1]].typ = ints; 
            cnonfatal("Type of function %s defaults to int",tab[yyvsp[-1]].name);
            tab[yyvsp[0]].obj = (extern_decl ? ext_function : function );
            void_function = 0;
         }
    break;
case 30:
#line 435 "bac.y"
{
            tab[yyvsp[-1]].typ = notyp;
            tab[yyvsp[-1]].obj = (extern_decl ? ext_procedure : procedure);
            yyval = yyvsp[-1];
            void_function = 1;
         }
    break;
case 31:
#line 442 "bac.y"
{
            if ((tab[yyvsp[-2]].typ != ints)&&(tab[yyvsp[-2]].typ != chars)){
               sprintf(pbuf,"'%s' is not a valid function return type",
                                 tab[yyvsp[-2]].name); 
               yyerror(pbuf); 
               tab[yyvsp[-1]].typ = notyp;
            } 
            else
               tab[yyvsp[-1]].typ = tab[yyvsp[-2]].typ;
            tab[yyvsp[-1]].obj = (extern_decl ? ext_function : function );
            yyval = yyvsp[-1];
            void_function = 0;
         }
    break;
case 32:
#line 458 "bac.y"
{ int vis_level,real_level;
            if (in_mon_decl) {
               real_level = level;
               vis_level = ((level > 0) ? level -1 : 0); 
            }
            else {
               vis_level = real_level = level;
            }
            yyval = prt = enter(lastident(),function,real_level,vis_level);
            func_tab = prt;
            if (in_mon_decl) tab[prt].mon = mtab[mon] - last_predeclared;
            enter_block(&last_btab,&level,prt);
            curr_parm_offset = btab[display[level]].vsize;
            delta_vsize = curr_parm_offset - btab[display[level]].psize;
            tab[yyval].adr = (extern_decl ?  -1 : lc);
            if (in_mon_decl&&!extern_decl) emit1(ENTERMON,tab[prt].mon);
         }
    break;
case 33:
#line 478 "bac.y"
{ btab[display[level]].lastpar = last_tab;}
    break;
case 39:
#line 491 "bac.y"
{
            tab[yyvsp[0]].typ = elem_typ;
            tab[yyvsp[0]].ref = elem_ref;
            tab[yyvsp[0]].obj = variable;
            tab[yyvsp[0]].lev = level;
            tab[yyvsp[0]].normal = by_value;
            tab[yyvsp[0]].adr = curr_parm_offset;
            if (by_value) 
               curr_parm_offset += elem_size;
            else
               curr_parm_offset++;  /* pointers occupy 1 stack word */
         }
    break;
case 40:
#line 506 "bac.y"
{ by_value = 1; }
    break;
case 41:
#line 508 "bac.y"
{ by_value = 0; }
    break;
case 42:
#line 510 "bac.y"
{ /* allow strings of indefinite length */
            elem_ref = 0;
            elem_size = 1;  /* a pointer */
            elem_typ  = strings;
            elem_tix = -1;
            by_value = 0;  /* pass-by-reference */
         }
    break;
case 43:
#line 521 "bac.y"
{
            leave_block(&level);
            in_mon_decl = 0;
         }
    break;
case 44:
#line 528 "bac.y"
{
            if (mon == MAXMON) 
               cfatal("No more than %d monitors can be declared",MAXMON);
            tab[yyvsp[0]].obj = (extern_decl ? ext_monitor : monitor);
            mtab[++mon] = yyvsp[0];
            in_mon_decl = 1;
            yyval = yyvsp[0];
            if (level > 0)
               yyerror("Monitors can only be declared at the global level");
            enter_block(&last_btab,&level,last_tab);
            btab[last_btab].lastpar = last_tab;  /* no parms */
         }
    break;
case 51:
#line 556 "bac.y"
{ 
            if (tab[mtab[mon]].obj == monitor) {
               /* don't do the following for ext_monitor objects */
               tab[mtab[mon]].adr = lc;      /* addr of monitor init code */
               process_var_inits(level);
               /* main pgm will CALL_MONINIT, even if no init code */
               emit(RET_MONINIT); 
            }
         }
    break;
case 52:
#line 566 "bac.y"
{
            if (tab[mtab[mon]].obj == monitor) {
               /* don't do the following for ext_monitor objects */
               /* main pgm will CALL_MONINIT, even if no init code */
               emit(RET_MONINIT); 
            }
         }
    break;
case 53:
#line 576 "bac.y"
{
            tab[mtab[mon]].adr = lc;      /* addr of monitor init code */
            process_var_inits(level);
         }
    break;
case 54:
#line 583 "bac.y"
{
               leave_block(&level);
               tab[yyvsp[-3]].adr = -1;
               extern_decl = 0;
               in_mon_decl = 0;
            }
    break;
case 55:
#line 592 "bac.y"
{ leave_block(&level); }
    break;
case 56:
#line 594 "bac.y"
{ leave_block(&level); }
    break;
case 60:
#line 603 "bac.y"
{
            if (level > 0)
            yyerror("Externals must be declared at the outer (global) level");
         }
    break;
case 62:
#line 613 "bac.y"
{ 
            yyval = elem_tix = int_loc; 
            elem_size = stacksize(tab[int_loc].adr); /* tab has byte size */
            elem_typ  = tab[int_loc].typ;
            elem_ref  = tab[int_loc].ref;
         }
    break;
case 63:
#line 620 "bac.y"
{ 
            yyval = elem_tix = char_loc; 
            elem_size = stacksize(tab[char_loc].adr);
            elem_typ  = tab[char_loc].typ;
            elem_ref  = tab[char_loc].ref;
         }
    break;
case 64:
#line 627 "bac.y"
{
            if (yyvsp[-1] <= 0)
               yyerror("A string of non-positive length is not valid");
            else {
               elem_ref = elem_size = stacksize(1 + yyvsp[-1]);  /* null terminator */
               elem_typ  = strings;
               elem_tix = -1;
            }
         }
    break;
case 65:
#line 637 "bac.y"
{ 
            if (tab[yyvsp[0]].obj != type){
               sprintf(pbuf,"'%s' is not a valid type",tab[yyvsp[0]].name);
               yyerror(pbuf);
            }
            elem_size = stacksize(tab[yyvsp[0]].adr); /* adr is size of type object */
            elem_typ = tab[yyvsp[0]].typ;
            elem_ref = tab[yyvsp[0]].ref;
            elem_tix = yyvsp[0];
         }
    break;
case 68:
#line 654 "bac.y"
{
            tab[yyvsp[0]].typ = elem_typ;
            tab[yyvsp[0]].obj = (extern_decl ? ext_variable : variable);
            tab[yyvsp[0]].ref = elem_ref;
            tab[yyvsp[0]].adr = btab[display[level]].vsize;
            btab[display[level]].vsize += elem_size;
         }
    break;
case 69:
#line 662 "bac.y"
{
            if (extern_decl) 
               yyerror("External variables cannot be initialized");
            else {
               tab[yyvsp[-2]].typ = elem_typ;
               tab[yyvsp[-2]].obj = variable;
               tab[yyvsp[-2]].ref = elem_ref;
               tab[yyvsp[-2]].adr = btab[display[level]].vsize;
               btab[display[level]].vsize += elem_size;
               if (tab[yyvsp[-2]].typ == conds)
                  yyerror("Cannot assign to a 'condition'");
               else if (tab[yyvsp[-2]].typ == bsems) {
                  if ((yyvsp[0] < 0)||(yyvsp[0] > 1)) 
                     yyerror("A binary semaphore can only become 0 or 1");
               }
               else if (tab[yyvsp[-2]].typ == sems) {
                  if (yyvsp[0] < 0)
                     yyerror("A semaphore cannot be negative");
               }
               else if ((tab[yyvsp[-2]].typ != ints) && (tab[yyvsp[-2]].typ != chars)) 
                  yyerror("'int' or 'char' type expected");
               else if (tab[yyvsp[-2]].typ != consttype)
                  yyerror("Type mismatch in assignment");
               if (((in_mon_decl)&&(!in_func_decl))||  /* global monitor vars */
                   ((level == 0)&&(!main_declared))){  /* global main vars */
                  /* in this case, must generate the init code later */
                  add_var_init(&curr_var,yyvsp[-2],level,yyvsp[0]); /* $3 is the value */
               }
               else {   /* declaration in a function */
                  emit2(LOAD_ADDR,tab[yyvsp[-2]].lev,tab[yyvsp[-2]].adr);
                  emit1(PUSH_LIT,yyvsp[0]);
                  emit(STORE);
               }               
            }  /* else not extern */
         }
    break;
case 70:
#line 698 "bac.y"
{ in_typedef = 0; }
    break;
case 71:
#line 702 "bac.y"
{ 
         int i;
         TYPES eltyp;
         int   elsize,elref;
            elsize = elem_size;
            eltyp = elem_typ;
            tab[yyvsp[-1]].obj = (extern_decl ? ext_variable : variable);
            tab[yyvsp[-1]].typ = arrays;
            tab[yyvsp[-1]].ref = yyval = yyvsp[0]; /* first atab index is passed up the tree */
            if (eltyp == arrays)
               elref = elem_ref;
            else
               elref = 0;
               /* if the array is multidimensional, then the last elref */
               /* should be zero; otherwise, the last (and first) elref */
               /* must be the atab index of the array                   */
            for (i= last_atab; i >= yyvsp[0]; i--){ /* work from 'back to front' */
               atab[i].elref = elref;
               atab[i].elsize = elsize;
               atab[i].size = (1 + atab[i].high - atab[i].low)*elsize;
               elsize = atab[i].size;
               atab[i].eltyp = eltyp;
               eltyp = arrays;
               elref = i;
            }
            tab[yyvsp[-1]].adr = btab[display[level]].vsize;
            if (!in_typedef) 
               btab[display[level]].vsize += elsize;
            array_defined = yyvsp[-1];
         }
    break;
case 72:
#line 735 "bac.y"
{ yyval = yyvsp[0]; /* only want to pass on atab index for first dim */}
    break;
case 74:
#line 740 "bac.y"
{
            if (last_atab == AMAX) 
               cfatal("Array table full with %d entries",AMAX);
            atab[++last_atab].inxtyp = consttype;
            if (yyvsp[-1] < 0) {
               sprintf(pbuf,"Array bound %d less than zero",yyvsp[-1]);
               yyerror(pbuf);
               atab[last_atab].high = 0;
            }
            else
               atab[last_atab].high = yyvsp[-1] - 1;
            atab[last_atab].low = 0;
            yyval = last_atab;  /* pass array tab index up the parse tree */
         }
    break;
case 75:
#line 757 "bac.y"
{
            yyval = yyvsp[-1];
            if (yyvsp[-1] > 0) {
               tab[yyvsp[-1]].obj = type;
               tab[yyvsp[-1]].typ = tab[yyvsp[-2]].typ;
               tab[yyvsp[-1]].ref = tab[yyvsp[-2]].ref; 
               tab[yyvsp[-1]].adr = tab[yyvsp[-2]].adr;
            }
            in_typedef = 0;
         }
    break;
case 76:
#line 768 "bac.y"
{
            yyval = array_defined;
            if (array_defined > 0) {
               tab[array_defined].obj = type;
               tab[array_defined].typ = arrays;
               tab[array_defined].ref = yyvsp[-1];  /* its atab index */
               /* adr field is the size fo the type in BYTES */
               /* atab size is in stack words */
               tab[array_defined].adr = sizeof(int)*atab[yyvsp[-1]].size;
            }
            in_typedef = 0;
         }
    break;
case 77:
#line 783 "bac.y"
{ in_typedef = 1; }
    break;
case 78:
#line 787 "bac.y"
{
            if ((tab[yyvsp[-4]].typ != ints)&&(tab[yyvsp[-4]].typ != chars))
               yyerror("Constants must be of type 'int' or 'char'");
            else {
               tab[yyvsp[-3]].typ = tab[yyvsp[-4]].typ;
               tab[yyvsp[-3]].adr = yyvsp[-1];    /* adr field of constant holds its val */
               tab[yyvsp[-3]].ref = 0;
            }
         }
    break;
case 79:
#line 799 "bac.y"
{ yyval = yyvsp[0]; }
    break;
case 80:
#line 801 "bac.y"
{ yyval = - yyvsp[0]; }
    break;
case 81:
#line 803 "bac.y"
{ yyval = yyvsp[0]; }
    break;
case 82:
#line 805 "bac.y"
{ consttype = chars; yyval = laststring[0]; }
    break;
case 83:
#line 809 "bac.y"
{ consttype = ints; }
    break;
case 84:
#line 811 "bac.y"
{  yyval = get_constant(tab[yyvsp[0]].name,level,&consttype); 
            if ((consttype != ints)&&(consttype != chars)) {
               yyerror("'int' or 'char' type expected");
               consttype = notyp;
            }
         }
    break;
case 85:
#line 820 "bac.y"
{ yyval = strtoi(numbertext,numberbase); }
    break;
case 90:
#line 830 "bac.y"
{ 
            leave_block(&level);
            in_func_decl = 0;
            extern_decl = 0; 
         }
    break;
case 91:
#line 838 "bac.y"
{ extern_decl = 1; }
    break;
case 92:
#line 842 "bac.y"
{ extern_decl = 0; }
    break;
case 93:
#line 846 "bac.y"
{ 
            extern_decl = 0; 
            in_typedef = 0;
         }
    break;
case 94:
#line 853 "bac.y"
{ extern_decl = 0; }
    break;
case 97:
#line 859 "bac.y"
{ yyerrok; }
    break;
case 98:
#line 861 "bac.y"
{ yyerrok; }
    break;
case 99:
#line 866 "bac.y"
{ yyval = -1; /* send back news that expr_list was empty */ }
    break;
case 106:
#line 878 "bac.y"
{ 
            process_breaks();
               /* continue loc is passed back on the value stack */
            process_continues(yyvsp[0]);
            leave_break_block(&break_level,&curr_break,&curr_cont);
         }
    break;
case 118:
#line 900 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            if (expr[yyvsp[-2]].typ != ints)
               yyerror("right parameter is not of type 'int'");
            else {
                  /* put the value of the id expr on the stack */
               gen_exprval(yyvsp[-2]);
               if (expr[yyvsp[-4]].typ == rawstrings)     /* raw str message */
                  emit1(SEND_RAWSTRING,expr[yyvsp[-4]].adr);
               else if (expr[yyvsp[-4]].typ == ints)      /* int message */
                  emit(SEND_INT);
               else if (expr[yyvsp[-4]].typ == strings)   /* msg is a string var */
                  emit(SEND_STRING);
               else
                  yyerror("parameter is not 'rawstring', 'string', or 'int'");
            }
            free_expr(yyvsp[-4]); free_expr(yyvsp[-2]);
         }
    break;
case 119:
#line 927 "bac.y"
{ yyval = yyvsp[0]; }
    break;
case 120:
#line 929 "bac.y"
{
            if (expr[yyvsp[0]].typ == strings) {
               /* left parm is a string. If it's not an array elt, */
               /* put the address of the string n the stack        */
               if (!expr[yyvsp[0]].arelt)
                  emit_push_addr(expr[yyvsp[0]]);
            }
            else if (expr[yyvsp[0]].typ == ints)
               gen_exprval(yyvsp[0]);  /* put the int on the stack */
            yyval = yyvsp[0];
         }
    break;
case 121:
#line 944 "bac.y"
{
            if (expr[yyvsp[0]].typ == rawstrings)     /* raw str message */
               emit1(BROADCAST_RAWSTRING,expr[yyvsp[0]].adr);
            else if (expr[yyvsp[0]].typ == strings)   /* msg is a string var */
               emit(BROADCAST_STRING);
            else if (expr[yyvsp[0]].typ == ints)      /* int msg */
               emit(BROADCAST_INT);
            else
               yyerror("parameter is not 'rawstring', 'string', or 'int'");
            free_expr(yyvsp[0]);
         }
    break;
case 122:
#line 958 "bac.y"
{
            /* push the parm count for interp's SPRINTF_OP to use */
            emit1(PUSH_LIT,varargs_cnt); 
            emit1(SPRINTF_OP,yyvsp[-3]);
         }
    break;
case 123:
#line 966 "bac.y"
{ 
            if (expr[yyvsp[-2]].typ != strings)
               yyerror("Leftmost sprintf parameter must be of type 'string'");
            yyval = expr[yyvsp[0]].adr;   /* pass raw string index up the tree */
            emit_push_addr(expr[yyvsp[-2]]);
            free_expr(yyvsp[-2]); free_expr(yyvsp[0]);
            varargs_cnt = 0;
         }
    break;
case 124:
#line 977 "bac.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sprintf parameter must be either of type 'int' or type 'string'");
            if (expr[yyvsp[0]].typ == strings)
               emit_push_addr(expr[yyvsp[0]]);
            else
               gen_exprval(yyvsp[0]);
            varargs_cnt++;
            free_expr(yyvsp[0]);
         }
    break;
case 125:
#line 989 "bac.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sprintf parameter must be either of type 'int' or type 'string'");
            if (expr[yyvsp[0]].typ == strings)
               emit_push_addr(expr[yyvsp[0]]);
            else
               gen_exprval(yyvsp[0]);
            varargs_cnt++;
            free_expr(yyvsp[0]);
         }
    break;
case 126:
#line 1003 "bac.y"
{ code[yyvsp[-1]].y = yyvsp[0]; }
    break;
case 127:
#line 1005 "bac.y"
{ code[yyvsp[-3]].y = yyvsp[-1]; code[yyvsp[-2]].y = lc; }
    break;
case 128:
#line 1007 "bac.y"
{ int i;
               /* switch_level is incremented in switch_hdr rule        */
               /* grammar also forces at least one case in every switch */
            i = case_loc[curr_case];
            code[i].y = yyvsp[-1];      /* JZER of the case */
            /* opcode of last test of swtich must pop the switch expr */
            code[i-1].f = TEST_EQ;
               /* the current case of the enclosing switch block is one */
               /* less than the first case of this block                */
            curr_case = switch_block[switch_level].first_case - 1;
            switch_level--;
            process_breaks();
            leave_break_block(&break_level,&curr_break,&curr_cont);
            free_expr(yyvsp[-4]);
         }
    break;
case 129:
#line 1025 "bac.y"
{ gen_exprval(yyvsp[-1]); yyval = lc; emit(JZER); free_expr(yyvsp[-1]); }
    break;
case 130:
#line 1029 "bac.y"
{ yyval = lc; }
    break;
case 131:
#line 1033 "bac.y"
{ emit(JUMP); yyval = lc; }
    break;
case 132:
#line 1037 "bac.y"
{ 
            enter_break_block(&break_level,switch_blk);
            if (++curr_case == MAXCASELOC)
               cfatal(
       "Can't more than %d 'case' statments in a nest of 'switch' stmts",
                  MAXCASELOC);
            gen_exprval(yyvsp[-1]);
            switch_level++;
            switch_block[switch_level].first_case = curr_case;
            switch_block[switch_level].expr_index = yyvsp[-1];
         }
    break;
case 136:
#line 1058 "bac.y"
{ first_case_hdr = curr_case; case_hdr_cnt = 1; }
    break;
case 137:
#line 1060 "bac.y"
{  case_hdr_cnt++; }
    break;
case 138:
#line 1064 "bac.y"
{ int i;
         i = switch_block[switch_level].expr_index;
         if ((expr[i].typ != expr[yyvsp[-1]].typ)&&(expr[yyvsp[-1]].typ != notyp)) 
            yyerror
               ("Case expression type differs from type of switch expression");
         else {
            gen_exprval(yyvsp[-1]);
            free_expr(yyvsp[-1]);
            emit(TEST_EQ_KEEP);
            if (++curr_case == MAXCASELOC)
               cfatal(
      "No more than %d 'case' statments in a nest of switch statements",
      MAXCASELOC);
            case_loc[curr_case] = lc;
            emit(JZER);
         }
      }
    break;
case 139:
#line 1084 "bac.y"
{  int j;
         j = switch_block[switch_level].first_case;
         if (case_hdr_cnt > 0) emit(JUMP); /* for multiple case labels */
         if (curr_case > j)
            code[case_loc[curr_case]].y = lc;  /* prev JZER target */
      }
    break;
case 140:
#line 1093 "bac.y"
{  int i, j, k;
         for (i = 1, j = first_case_hdr; i < case_hdr_cnt; i++, j++ ) {
            k = case_loc[j]; 
            code[k+1].y = lc;    /* k+1 == address of JMP to stmt_list */
         }
         case_hdr_cnt = 0; /* reload for next time */
         first_case_hdr = -1;
      }
    break;
case 141:
#line 1104 "bac.y"
{ yyval = lc; }
    break;
case 143:
#line 1109 "bac.y"
{ yyval = lc; }
    break;
case 144:
#line 1113 "bac.y"
{ if (level == 1) emit(COEND); in_cobegin = 0; }
    break;
case 145:
#line 1117 "bac.y"
{
            yyval = yyvsp[-2];             /* continue target */
            emit1(JUMP,yyvsp[-2]); 
            code[yyvsp[-1]].y = lc; 
         }
    break;
case 146:
#line 1123 "bac.y"
{  
            yyval = yyvsp[-2];             /* continue target */
            code[yyvsp[-1]].y = yyvsp[-4];     /* point JUMP to top of DO */
         }
    break;
case 147:
#line 1128 "bac.y"
{ int i; 
            if (yyvsp[-2]) {            /* iteration code was generated */
               yyval = for_info[curr_for].iter_loc;  /* continue target */
               /* jump back to iteration code after stmt */
               emit1(JUMP,for_info[curr_for].iter_loc); 
               if (yyvsp[-4]) {         /* if there was continuation code .. */
                  i = for_info[curr_for].stmt_loc - 1;/* JUMP from iter code */
                  code[i].y = for_info[curr_for].cont_loc;  /* to cont code */
               }
               /* will fall through to stmt from iter code if no cond code */
            }
            else {             /* no iteration code was generated */
               yyval = for_info[curr_for].stmt_loc;    /* continue target */ 
               if (yyvsp[-4])        /* if there is continuation code ... */
                  emit1(JUMP,for_info[curr_for].cont_loc);  /* jmp to it */
               else           /* else jmp back to stmt code */
                  emit1(JUMP,for_info[curr_for].stmt_loc);  /* jmp to it */
            }
            if (yyvsp[-4])           /* if there was continuation code... */
               code[for_info[curr_for].cont_jzer].y = lc;   /* jmp out */  
            code[for_info[curr_for].iter_loc-1].y = 
                                             for_info[curr_for].stmt_loc;
            curr_for--;
         }
    break;
case 148:
#line 1155 "bac.y"
{ 
            yyval = lc;   /* continue target */ 
            enter_break_block(&break_level,loop_blk);
         }
    break;
case 149:
#line 1162 "bac.y"
{ 
            gen_exprval(yyvsp[-1]); 
            free_expr(yyvsp[-1]); 
            yyval = lc; 
            emit(JZER);
         }
    break;
case 150:
#line 1171 "bac.y"
{ 
            enter_break_block(&break_level,loop_blk);
         }
    break;
case 151:
#line 1177 "bac.y"
{ yyval = lc; /* location of stmt code */ }
    break;
case 152:
#line 1181 "bac.y"
{ yyval = lc;  /* continue target */ }
    break;
case 153:
#line 1185 "bac.y"
{ 
            gen_exprval(yyvsp[-1]); 
            free_expr(yyvsp[-1]); 
            emit1(JZER,lc+2);
            yyval = lc;    /* pass loc of JUMP up parse tree */
            emit(JUMP);
         }
    break;
case 154:
#line 1195 "bac.y"
{ /* init stuff done, continuation testing code is next */
            for_info[curr_for].cont_loc  = lc;  /* continuation test code */
         }
    break;
case 155:
#line 1201 "bac.y"
{ 
            enter_break_block(&break_level,loop_blk);
            if (++curr_for == MAXFORNEST)
               cfatal("No more than %d 'for' statements can be nested",
                  MAXFORNEST);
            else {
               for_info[curr_for].iter_loc = for_info[curr_for].cont_loc = -1;
               for_info[curr_for].cont_jzer = for_info[curr_for].stmt_loc = -1;
            }
         }
    break;
case 156:
#line 1214 "bac.y"
{ yyval = 0;   /* no continuation code */ }
    break;
case 157:
#line 1216 "bac.y"
{ 
            yyval = 1;  /* continuation code */
            gen_exprval(yyvsp[0]);  /* expr might not have been generated yet */
            free_expr(yyvsp[0]);
            for_info[curr_for].cont_jzer = lc;    /* mark loc of JZER */
            emit(JZER);
         }
    break;
case 158:
#line 1226 "bac.y"
{
            emit(JUMP);       /* to stmt code, backpatched later */
            for_info[curr_for].iter_loc = lc; /* loc of iteration code */ 
         }
    break;
case 159:
#line 1233 "bac.y"
{ 
            yyval = 0;   /* no iteration code */
            for_info[curr_for].stmt_loc = lc;   /* loc of stmt code */
         }
    break;
case 160:
#line 1238 "bac.y"
{
            yyval = 1;   /* iteration code */
            if (for_info[curr_for].cont_jzer >= 0) /* there was cont code */
               emit(JUMP);       /* to continuation code, backpatched */
            for_info[curr_for].stmt_loc = lc;   /* loc of stmt code */
         }
    break;
case 161:
#line 1247 "bac.y"
{
            if (level != 1)
               yyerror("'cobegin' block allowed only in 'main'");
            else if (in_cobegin)
               yyerror("'cobegin' blocks cannot be nested");
            else
               emit(COBEGIN);
            in_cobegin = 1;
         }
    break;
case 162:
#line 1259 "bac.y"
{
            if ((break_level < 0)||
               (break_block[break_level].bb_type != loop_blk))
               yyerror("'continue' is inappropriate outside a loop");
            else {
               if (++curr_cont == MAXCONT)
                  cfatal(
                     "Can't have more than %d 'continue' statements in a loop",
                     MAXCONT);
               else {
                  cont_loc[curr_cont] = lc;
                  if (break_block[break_level].first_cont < 0)
                     break_block[break_level].first_cont = curr_cont;
                  emit(JUMP);
               }
            }
         }
    break;
case 163:
#line 1279 "bac.y"
{
            if (break_level < 0)
   yyerror("'break' is inappropriate outside a 'loop' or 'switch' statement");
            else {
               if (++curr_break == MAXBREAK)
                  cfatal(
         "Can't have more than %d 'breaks' in a nest of loop or switch stmts",
                     MAXBREAK);
               else {
                  break_loc[curr_break] = lc;
                  if (break_block[break_level].first_break < 0) 
                     break_block[break_level].first_break = curr_break;
                  emit(JUMP);
               }
            }
         }
    break;
case 164:
#line 1298 "bac.y"
{  
            if (void_function) {
               if (yyvsp[-1] < 0)
                  emit(EXIT_PROC); 
               else
                  yyerror("Cannot return a value from a 'void' function");
            }
            if (yyvsp[-1] >= 0) 
               gen_exprval(yyvsp[-1]); 
            else  /* no expression to push */
               emit1(PUSH_LIT,0); 
            emit(STORE); 
            if (++curr_ret == MAXRETURN)
               cfatal(
   "No more thn %d 'return' statements can appear in a function",MAXRETURN);
            else
               return_loc[curr_ret] = lc;    /* mark the JUMP loc */
            emit(JUMP);   /* jump to fcn exit*/ 
         }
    break;
case 165:
#line 1320 "bac.y"
{ 
            if (!in_func_decl)
               yyerror("'return' is inappropriate outside a function");
            else if (!void_function)
                  emit2(LOAD_ADDR,tab[func_tab].lev+1,0);
         }
    break;
case 169:
#line 1336 "bac.y"
{
            if (expr[yyvsp[0]].typ == arrays) /* presently our only struct type */
               yyerror("Cannot output an array");
            else if(expr[yyvsp[0]].typ == strings) {
               /* an array ref ==> addr is _aldready_ on stack */
               if (!expr[yyvsp[0]].arelt)
                  emit_push_addr(expr[yyvsp[0]]);
               emit(WRITE_STRING);
            }
            else{
               gen_exprval(yyvsp[0]);
               emit1(WRITE,expr[yyvsp[0]].typ);
            }
            free_expr(yyvsp[0]);
         }
    break;
case 170:
#line 1352 "bac.y"
{ emit(WRITELN); }
    break;
case 171:
#line 1354 "bac.y"
{  
            int tmp = store_string(laststring,&stab_size);
            emit1(WRITE_RAWSTRING,tmp);
         }
    break;
case 172:
#line 1361 "bac.y"
{
            if ((expr[yyvsp[-1]].obj != variable)&& (expr[yyvsp[-1]].obj != ext_variable))
               yyerror("input item must be a 'variable'");
            else if ((expr[yyvsp[-1]].typ != ints)&&(expr[yyvsp[-1]].typ != chars)&&
                     (expr[yyvsp[-1]].typ != notyp))
               yyerror("input item must be of type 'int' or 'char'");
            else if (!expr[yyvsp[-1]].arelt){ 
               emit_push_addr(expr[yyvsp[-1]]);
               emit1(READ,expr[yyvsp[-1]].typ);
            } else   /* array element */
               emit1(READ,expr[yyvsp[-1]].typ);
         }
    break;
case 174:
#line 1378 "bac.y"
{ yyval = -1; }
    break;
case 176:
#line 1383 "bac.y"
{  int i = expr[yyvsp[-1]].tix;
            if ((tab[i].obj == function) && (!expr[yyvsp[-1]].result_used))
               yyerror("A non-void function cannot be called as a void function");
            free_expr(yyvsp[-1]); 
         }
    break;
case 179:
#line 1395 "bac.y"
{
            expr[yyvsp[0]].result_used = 1;
            gen_exprval(yyvsp[0]);
            if (tab[yyvsp[-1]].typ == expr[yyvsp[0]].typ) {
               if ((tab[yyvsp[-1]].typ == sems)||(tab[yyvsp[-1]].typ == bsems)|| 
                   (tab[yyvsp[-1]].typ == conds))
                  yyerror("Cannot assign to 'semaphore' or 'condition'");
               else if (tab[yyvsp[-1]].typ == arrays)
                  emit1(COPY_BLOCK,atab[tab[yyvsp[-1]].ref].size);
               else  /* standard types */
                  if (assign_cnt > 1)  /* multiple assignments */
                     emit(STORE_KEEP);
                  else                 /* last assignment */
                     emit(STORE);
            }
            else
               yyerror("Type mismatch in assignment");
            yyval = yyvsp[0];
            assign_cnt--;
         }
    break;
case 180:
#line 1416 "bac.y"
{
            gen_exprval(yyvsp[0]);
            if (expr[yyvsp[-1]].typ == expr[yyvsp[0]].typ) {
               if ((expr[yyvsp[-1]].typ == sems)||(expr[yyvsp[-1]].typ == bsems)|| 
                   (expr[yyvsp[-1]].typ == conds))
                  yyerror("Cannot assign to 'semaphore' or 'condition'");
               else if (expr[yyvsp[-1]].typ == arrays)
                  emit1(COPY_BLOCK,atab[tab[yyvsp[-1]].ref].size);
               else  /* standard types */
                  if (assign_cnt > 1)  /* multiple assignments */
                     emit(STORE_KEEP);
                  else                 /* last assignment */
                     emit(STORE);
            }
            else
               yyerror("Type mismatch in assignment");
            expr[yyvsp[-1]].isval = 1;
            yyval = yyvsp[-1];
            assign_cnt--;
         }
    break;
case 181:
#line 1439 "bac.y"
{
            assign_cnt++;
            if ((tab[yyvsp[-1]].obj == variable)||(tab[yyvsp[-1]].obj == ext_variable)) {
               if ((tab[yyvsp[-1]].typ == sems)||(tab[yyvsp[-1]].typ == bsems))
                  yyerror("Must use `initialsem' to initialize a 'semaphore'");
               else
                  emit_push_addr(tab[yyvsp[-1]]);
            }
            else
               yyerror("'variable' identifier expected");
         }
    break;
case 182:
#line 1453 "bac.y"
{ assign_cnt++; }
    break;
case 184:
#line 1458 "bac.y"
{
            if ((expr[yyvsp[-2]].typ == ints)&&(expr[yyvsp[0]].typ == ints)) {
               gen_exprval(yyvsp[0]);
               emit(DO_OR);
            }
            else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
               yyerror("type 'int' expected");
               expr[yyvsp[-2]].typ = notyp;
            }
            free_expr(yyvsp[0]);
         }
    break;
case 185:
#line 1472 "bac.y"
{ gen_exprval(yyvsp[0]); }
    break;
case 187:
#line 1477 "bac.y"
{
            if ((expr[yyvsp[-2]].typ == ints)&&(expr[yyvsp[0]].typ == ints)) {
               gen_exprval(yyvsp[0]);
               emit(DO_AND);
            }
            else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
               yyerror("'int' type expected");
               expr[yyvsp[-2]].typ = notyp;
            }
            free_expr(yyvsp[0]);
         }
    break;
case 188:
#line 1491 "bac.y"
{ gen_exprval(yyvsp[0]); }
    break;
case 190:
#line 1496 "bac.y"
{
            gen_exprval(yyvsp[0]);
            if (expr[yyvsp[-2]].typ == expr[yyvsp[0]].typ){
               if ((expr[yyvsp[-2]].typ == ints)||(expr[yyvsp[-2]].typ == chars))
                  emit(yyvsp[-1]);
               else
                  yyerror("Only 'int' and 'char' types can be compared");
            }
            else
               yyerror("Types in comparison are unequal");
            expr[yyvsp[-2]].typ = ints;
            expr[yyvsp[-2]].isval = 1;
            free_expr(yyvsp[0]);
         }
    break;
case 191:
#line 1513 "bac.y"
{ gen_exprval(yyvsp[0]); }
    break;
case 192:
#line 1516 "bac.y"
{ yyval = TEST_EQ; }
    break;
case 193:
#line 1517 "bac.y"
{ yyval = TEST_LT; }
    break;
case 194:
#line 1518 "bac.y"
{ yyval = TEST_GT; }
    break;
case 195:
#line 1519 "bac.y"
{ yyval = TEST_LE; }
    break;
case 196:
#line 1520 "bac.y"
{ yyval = TEST_GE; }
    break;
case 197:
#line 1521 "bac.y"
{ yyval = TEST_NE; }
    break;
case 199:
#line 1526 "bac.y"
{
            yyval = yyvsp[0];
            gen_exprval(yyval);
            if ((expr[yyval].typ != ints)&&(expr[yyval].typ != notyp)){
               yyerror("'int' type expected");
               expr[yyval].typ = notyp;
            }
         }
    break;
case 200:
#line 1535 "bac.y"
{
            yyval = yyvsp[0];
            gen_exprval(yyval);
            if ((expr[yyval].typ != ints)&&(expr[yyval].typ != notyp)){
               yyerror("type 'int' expected");
               expr[yyval].typ = notyp;
            }
            else
               emit(NEGATE);
         }
    break;
case 201:
#line 1546 "bac.y"
{
            gen_exprval(yyvsp[0]);
            switch (yyvsp[-1]) {
            case DO_ADD:
            case DO_SUB:
               expr[yyvsp[-2]].typ = resulttype(expr[yyvsp[-2]].typ,expr[yyvsp[0]].typ);
               if (expr[yyvsp[-2]].typ == ints)
                  emit(yyvsp[-1]);
               break;
            default:
               fatal("grammar error:  bad add_op %d in simp_expr",yyvsp[-1]);
            } /* switch */
            free_expr(yyvsp[0]);
         }
    break;
case 202:
#line 1563 "bac.y"
{ gen_exprval(yyvsp[0]); }
    break;
case 203:
#line 1566 "bac.y"
{ yyval = DO_ADD; }
    break;
case 204:
#line 1567 "bac.y"
{ yyval = DO_SUB; }
    break;
case 206:
#line 1572 "bac.y"
{
            gen_exprval(yyvsp[0]);
            switch(yyvsp[-1]) {
            case DO_MUL:
            case DO_DIV:
            case DO_MOD:
               if ((expr[yyvsp[-2]].typ == ints)&&(expr[yyvsp[0]].typ == ints))
                  emit(yyvsp[-1]);
               else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
                  yyerror("type 'int' expected");
                  expr[yyvsp[-2]].typ = notyp;
               }
               break;
            default:
               fatal("grammar error:  bad mult_op %d in term",yyvsp[-1]);
            } /* switch */
            free_expr(yyvsp[0]);
         }
    break;
case 207:
#line 1593 "bac.y"
{ gen_exprval(yyvsp[0]); }
    break;
case 208:
#line 1596 "bac.y"
{ yyval = DO_MUL; }
    break;
case 209:
#line 1597 "bac.y"
{ yyval = DO_DIV; }
    break;
case 210:
#line 1598 "bac.y"
{ yyval = DO_MOD; }
    break;
case 212:
#line 1603 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = constant;
            expr[yyval].adr = yyvsp[0];
            expr[yyval].typ = ints;
            expr[yyval].lev = level;
         }
    break;
case 213:
#line 1611 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = constant;
            expr[yyval].adr = laststring[0];
            expr[yyval].typ = chars;
            expr[yyval].lev = level;
         }
    break;
case 214:
#line 1619 "bac.y"
{ yyval = yyvsp[-1];}
    break;
case 215:
#line 1621 "bac.y"
{
            yyval = yyvsp[0];
            gen_exprval(yyval);
            if (expr[yyval].typ == ints)
               emit(COMPLEMENT);
            else if (expr[yyval].typ != notyp){
               yyerror("type 'int' expected");
               expr[yyval].typ = notyp;
            }
         }
    break;
case 217:
#line 1635 "bac.y"
{
            if ((expr[yyvsp[-1]].typ != ints)&&(expr[yyvsp[-1]].typ != chars))
               yyerror("'int' or 'char' expected");
            else {
               emit_push_addr(expr[yyvsp[-1]]);
               gen_loadvar(yyvsp[-1]);
               emit1(PUSH_LIT,1);
               emit(DO_ADD);
               emit(STORE);
            }
         }
    break;
case 218:
#line 1647 "bac.y"
{
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != chars))
               yyerror("'int' or 'char' expected");
            else {
               emit_push_addr(expr[yyvsp[0]]);
               gen_loadvar(yyvsp[0]);
               emit1(PUSH_LIT,1);
               emit(DO_ADD);
               emit(STORE);
            }
         }
    break;
case 219:
#line 1659 "bac.y"
{
            if ((expr[yyvsp[-1]].typ != ints)&&(expr[yyvsp[-1]].typ != chars))
               yyerror("'int' or 'char' expected");
            else {
               emit_push_addr(expr[yyvsp[-1]]);
               gen_loadvar(yyvsp[-1]);
               emit1(PUSH_LIT,1);
               emit(DO_SUB);
               emit(STORE);
            }
         }
    break;
case 220:
#line 1671 "bac.y"
{
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != chars))
               yyerror("'int' or 'char' expected");
            else {
               emit_push_addr(expr[yyvsp[0]]);
               gen_loadvar(yyvsp[0]);
               emit1(PUSH_LIT,1);
               emit(DO_SUB);
               emit(STORE);
            }
         }
    break;
case 224:
#line 1688 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = tab[yyvsp[0]].obj;
            expr[yyval].typ = tab[yyvsp[0]].typ;
            expr[yyval].adr = tab[yyvsp[0]].adr;
            expr[yyval].ref = tab[yyvsp[0]].ref;
            expr[yyval].lev = tab[yyvsp[0]].lev;
            expr[yyval].normal = tab[yyvsp[0]].normal;
            expr[yyval].tix = yyvsp[0];
         }
    break;
case 225:
#line 1701 "bac.y"
{ int k; 
            yyval = new_expr();
            expr[yyval].obj = tab[yyvsp[-1]].obj;
            expr[yyval].typ = tab[yyvsp[-1]].typ;
            expr[yyval].adr = tab[yyvsp[-1]].adr;
            expr[yyval].ref = tab[yyvsp[-1]].ref;
            expr[yyval].lev = tab[yyvsp[-1]].lev;
            expr[yyval].normal = tab[yyvsp[-1]].normal;
            expr[yyval].tix = yyvsp[-1];
            if (tab[yyvsp[-1]].lev == -1)  /* std function unfinished business */
               stdproc_pcode(yyvsp[-1],parmct);
            else if ((tab[yyvsp[-1]].obj == function)||(tab[yyvsp[-1]].obj == procedure)||
               (tab[yyvsp[-1]].obj == ext_function)||(tab[yyvsp[-1]].obj == ext_procedure)) {
               expr[yyval].ref = 0;   /* in a func call ref field of func == 0 */
               /* first check on too few parms */
               k = btab[tab[yyvsp[-1]].ref].lastpar - yyvsp[-1];
               if ((k > parmct)&&(first_parmcterr)) {
                  sprintf(pbuf,"Too few actual parameters in the %s call",
                     tab[yyvsp[-1]].name);
                  yyerror(pbuf);
                  first_parmcterr = 0;
               }
               if ((in_cobegin)&&(tab[yyvsp[-1]].typ != notyp)) 
                  yyerror("Only VOID function calls are allowed in a \
cobegin block");
               k = btab[tab[yyvsp[-1]].ref].psize - 1;
               if (tab[yyvsp[-1]].mon == 0)
                  emit2(CALL,0,k);
               else
                  emit2(CALL,-1,k); /* CALL pcode: x == -1 => mon call */
               if (tab[yyvsp[-1]].lev < level) /* update display, ord nesting*/
                  emit2(UPDATE_DISPLAY,tab[yyvsp[-1]].lev,level);
               else if ((tab[yyvsp[-1]].mon)&&(level == tab[yyvsp[-1]].lev))
               /* must fix display differently for monitor call */
                  emit2(UPDATE_DISPLAY,level-1,level);
            }
            toppfs--;
            if (toppfs < 0 )
               parmct = last_pf = 0;
            else {
               parmct = pfstack[toppfs].pct;
               last_pf = pfstack[toppfs].tix;
            }
         }
    break;
case 228:
#line 1750 "bac.y"
{
            last_pf = yyvsp[0];
            if ((tab[yyvsp[0]].obj != function)&&(tab[yyvsp[0]].obj != procedure)&&
                (tab[yyvsp[0]].obj != ext_function)&&(tab[yyvsp[0]].obj != ext_procedure))
               yyerror("'function call' expected");
            else { /* tab[$1].obj == procedure or function or stdproc*/
               if ((++toppfs) == MAXPFNEST)
                  yyerror("Maximum function call nesting exceeded");
               else{  /* legal func call */
                  pfstack[toppfs].tix = last_pf; 
                  pfstack[toppfs].pct = parmct = 0;
                  first_stringerr = first_parmcterr = 1;
                  if (tab[yyvsp[0]].lev != -1){ /* regular proc call */
                     if ((tab[yyvsp[0]].mon)&&(tab[prt].mon)&&
                         (tab[yyvsp[0]].mon != tab[prt].mon))
                        yyerror("Cross monitor calls not allowed");
                     emit1(MARKSTACK,last_pf-last_predeclared);
                  } /* if regular proc */
               } /* legal func call */ 
            } /* if func */
         }
    break;
case 233:
#line 1782 "bac.y"
{
            parmct = ++pfstack[toppfs].pct;
            if (tab[last_pf].lev == -1)
               stdproc_parm(last_pf,yyvsp[0],parmct);
            else
               proc_parm(last_pf,yyvsp[0],parmct);
            free_expr(yyvsp[0]);
         }
    break;
case 239:
#line 1800 "bac.y"
{
            if (expr[yyvsp[-1]].typ != strings)
               yyerror("left parameter is not of type 'string'");
            yyval = NO_EXPR;     /* for free_expr() call up the parse tree */
            if (expr[yyvsp[0]].typ == rawstrings) 
               emit1(CONCAT_RAWSTRING,expr[yyvsp[0]].adr);
            else 
               emit(CONCAT_STRING);
            free_expr(yyvsp[-1]); free_expr(yyvsp[0]);
         }
    break;
case 240:
#line 1813 "bac.y"
{
            if (expr[yyvsp[-1]].typ != strings) {
               yyerror("right parameter is not of type 'string'");
               last_eltyp = notyp;
            }
            else {
               if (!expr[yyvsp[-1]].arelt)
                  /* push addr of source string */
                  /* addr of array ref is already on the stack */
                  emit_push_addr(expr[yyvsp[-1]]);
            }
         }
    break;
case 241:
#line 1826 "bac.y"
{ yyval = yyvsp[-1]; }
    break;
case 242:
#line 1830 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = variable;
            expr[yyval].typ = rawstrings;
            expr[yyval].adr = store_string(laststring,&stab_size);
            expr[yyval].ref = 1 + strlen(laststring); /* includes null char */
            expr[yyval].normal = 1;
            expr[yyval].tix = -1;
         }
    break;
case 243:
#line 1842 "bac.y"
{
            if (expr[yyvsp[-1]].typ != strings)
               yyerror("left parameter is not of type 'string'");
            yyval = NO_EXPR;     /* for free_expr() call up the parse tree */
            if (expr[yyvsp[0]].typ == rawstrings) 
               emit1(COPY_RAWSTRING,expr[yyvsp[0]].adr);
            else 
               emit(COPY_STRING);
            free_expr(yyvsp[-1]); free_expr(yyvsp[0]);
         }
    break;
case 244:
#line 1855 "bac.y"
{
            if (expr[yyvsp[-1]].typ != strings)
               yyerror("left parameter is not of type 'string'");
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            if (expr[yyvsp[0]].typ == rawstrings) 
               emit1(COMPARE_RAWSTRING,expr[yyvsp[0]].adr);
            else 
               emit(COMPARE_STRING);
            free_expr(yyvsp[0]);
         }
    break;
case 245:
#line 1874 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            if (expr[yyvsp[0]].typ == rawstrings)
                  /* user wants length of a rawtring !???!!! */
                  /* let 'em have it */
               emit1(PUSH_LIT,expr[yyvsp[0]].ref - 1);
            else  /* was a string variable */
               emit(LENGTH_STRING);
            free_expr(yyvsp[0]);
         }
    break;
case 246:
#line 1893 "bac.y"
{
            if (expr[yyvsp[-1]].typ == strings) {
                 if (!expr[yyvsp[-1]].arelt)
                  /* addr of array ref is already on the stack */
                  emit_push_addr(expr[yyvsp[-1]]);
            } else if (expr[yyvsp[-1]].typ == ints)
               gen_exprval(yyvsp[-1]);
            yyval = yyvsp[-1];
            /* parent rule will free_expr($2) */
         }
    break;
case 247:
#line 1904 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = variable;
            expr[yyval].typ = rawstrings;
            expr[yyval].adr = store_string(laststring,&stab_size);
            expr[yyval].ref = 1 + strlen(laststring); /* includes null char */
            expr[yyval].normal = 1;
            expr[yyval].tix = -1;
         }
    break;
case 248:
#line 1916 "bac.y"
{
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            /* push the parm count for interp's SSCANF_OP to use */
            emit1(PUSH_LIT,varargs_cnt); 
            emit1(SSCANF_OP,yyvsp[-3]);
         }
    break;
case 249:
#line 1931 "bac.y"
{ 
            if (expr[yyvsp[-2]].typ != strings)
               yyerror("Leftmost sscanf parameter must be of type 'string'");
            yyval = expr[yyvsp[0]].adr;  /* pass rawstring index up the tree */
            emit_push_addr(expr[yyvsp[-2]]);
            free_expr(yyvsp[-2]); free_expr(yyvsp[0]);
            varargs_cnt = 0;
         }
    break;
case 250:
#line 1942 "bac.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sscanf parameter must be either of type 'int' or type 'string'");
            emit_push_addr(expr[yyvsp[0]]);
            varargs_cnt++;
            free_expr(yyvsp[0]);
         }
    break;
case 251:
#line 1951 "bac.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sscanf parameter must be either of type 'int' or type 'string'");
            emit_push_addr(expr[yyvsp[0]]);
            varargs_cnt++;
            free_expr(yyvsp[0]);
         }
    break;
case 252:
#line 1962 "bac.y"
{
            if (expr[yyvsp[-1]].typ != strings)
               yyerror("Left parameter must be of type 'string'");
            emit(RECEIVE_OP);
            free_expr(yyvsp[-1]);   
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
         }
    break;
case 253:
#line 1976 "bac.y"
{
            if (expr[yyvsp[-3]].typ != strings)
               yyerror("Left parameter must be of type 'string'");
            /* implements receive(string,int&) call */
            if ((expr[yyvsp[-1]].obj != variable)&& (expr[yyvsp[-1]].obj != ext_variable))
               yyerror("the right 'receive' parameter must be a variable");
            else if (expr[yyvsp[-1]].typ != ints)
               yyerror("the right 'receive' parameter must be of type 'int'");
            else {
               if (!expr[yyvsp[-1]].arelt)
                  emit_push_addr(expr[yyvsp[-1]]);
               emit(RECEIVE_ID);
            }
            free_expr(yyvsp[-3]); free_expr(yyvsp[-1]);
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
         }
    break;
case 254:
#line 2001 "bac.y"
{
            expr[yyvsp[-1]].ref = sizeof(int)*atab[last_aref].elsize;
            expr[yyvsp[-1]].arelt = 1;
            expr[yyvsp[-1]].typ = last_eltyp;
            topars--;
            if (topars >= 0) {
               last_aref = arstack[topars].aref;
               last_eltyp = arstack[topars].eltyp;
            }
         }
    break;
case 255:
#line 2014 "bac.y"
{
            if (tab[yyvsp[0]].typ != arrays) {
               sprintf(pbuf,"'%s' is not of type 'array'",tab[yyvsp[0]].name);
               yyerror(pbuf);
               last_aref = 0;
               last_eltyp = notyp;
            }
            else {
               last_aref = tab[yyvsp[0]].ref;
               last_eltyp = atab[last_aref].eltyp;
               /* put addr of array base on the stack */
               emit_push_addr(tab[yyvsp[0]]);
            }
            if (++topars > MAXARNEST) 
               yyerror("Maximum array nesting exceeded");
            else {
               arstack[topars].aref = last_aref;
               arstack[topars].eltyp = last_eltyp;
            }
            yyval = new_expr();
            expr[yyval].obj = tab[yyvsp[0]].obj;
            expr[yyval].typ = tab[yyvsp[0]].typ;
            expr[yyval].adr = tab[yyvsp[0]].adr;
            expr[yyval].ref = tab[yyvsp[0]].ref;
            expr[yyval].lev = tab[yyvsp[0]].lev;
            expr[yyval].normal = tab[yyvsp[0]].normal;
         }
    break;
case 256:
#line 2044 "bac.y"
{ 
            gen_exprval(yyvsp[-1]);
            last_aref = arstack[topars].aref;
            last_eltyp = arstack[topars].eltyp;
            index_expr(yyvsp[-1],&last_aref,&last_eltyp); 
            arstack[topars].aref = last_aref;
            arstack[topars].eltyp = last_eltyp;
            free_expr(yyvsp[-1]); 
         }
    break;
case 257:
#line 2054 "bac.y"
{ 
            gen_exprval(yyvsp[-1]);
            last_aref = arstack[topars].aref;
            last_eltyp = arstack[topars].eltyp;
            index_expr(yyvsp[-1],&last_aref,&last_eltyp); 
            arstack[topars].aref = last_aref;
            arstack[topars].eltyp = last_eltyp;
            free_expr(yyvsp[-1]); 
         }
    break;
case 258:
#line 2066 "bac.y"
{
            expr[yyvsp[-1]].typ = ints;
            yyval = yyvsp[-1];
         }
    break;
case 259:
#line 2073 "bac.y"
{ yyval = loc(lastident(),level); }
    break;
case 260:
#line 2077 "bac.y"
{ yyval = enter(lastident(),constant,level,level); }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 2081 "bac.y"
   /*start of routines*/

void enter_break_block(int* break_level, break_block_type bbt)
{
   (*break_level)++;
   if (*break_level == MAXBRNEST)
      cfatal(
"Can't nest for, do, while, or switch stmts more deeply than %d levels",
MAXBRNEST);
   break_block[*break_level].first_break = -1;
   break_block[*break_level].first_cont  = -1;
   break_block[*break_level].bb_type     = bbt;
}


void leave_break_block(int* break_level, int* curr_break, int* curr_cont)
{
   if (*break_level < 0) {
      *curr_cont = *curr_break = -1;
      return;
   }
      /* the current continue of the outer block is one less than the */
      /* first continue of this block                                 */
   if (break_block[*break_level].first_cont >= 0)
      *curr_cont  = break_block[*break_level].first_cont - 1;
      /* same holds for break stmts, too */
   if (break_block[*break_level].first_break >= 0)
      *curr_break = break_block[*break_level].first_break - 1;
   (*break_level)--;
}


void
process_breaks()
{ 
   int i;
   if (break_level < 0) return;
   if (break_block[break_level].first_break < 0 ) return;
      /* backpatch all of the break targets in this block */
   for (i = break_block[break_level].first_break; i <= curr_break; i++) 
      code[break_loc[i]].y = lc;
}

void process_continues(int lc)
{
   int i;
   if (break_level < 0) return;
   if (break_block[break_level].first_cont < 0 ) return;
      /* backpatch all continue targets in this block */
   for (i = break_block[break_level].first_cont; i <= curr_cont; i++) 
      code[cont_loc[i]].y = lc;
}

void process_returns()
{
   int i;
   if (curr_ret >= 0) {
      for (i = 0; i <= curr_ret; i++)
         code[return_loc[i]].y = lc;   /* point JUMP @ RETURN to fcn exit */
   }
}

void process_var_inits(int levl)
{
   int i;
   if (curr_var >= 0) {
      for (i = 0; i <= curr_var; i++) {
         if (levl == var_init[i].lev) {
            emit2(LOAD_ADDR,tab[var_init[i].tix].lev,tab[var_init[i].tix].adr);
            emit1(PUSH_LIT,var_init[i].value);
            emit(STORE);
            var_init[i].lev = -1;
         }  /* if */
      }  /* for */
   }  /* if */
}

void add_var_init(int* curr_var, int tix, int level, int value)
{
   if (++(*curr_var) == MAXVARINIT) {
      sprintf(pbuf, 
         "No more than %d variables in a program can be initialized",
         MAXVARINIT);
      yyerror(pbuf);
   }
   else {
      var_init[*curr_var].value = value; 
      var_init[*curr_var].lev = level;
      var_init[*curr_var].tix = tix;
   }
}


/*
 *
 *  $Log: bac.y,v $
 *  Revision 2.25  2004/04/13 18:18:40  bynum
 *  revise grammar to handle C-style expressions
 *
 *  Revision 2.24  2004/04/11 20:57:41  bynum
 *  fix parse stack index error in assignment
 *
 *  Revision 2.23  2003/05/14 14:47:13  bynum
 *  add missing semicolons
 *
 *  Revision 2.22  2002/03/21 14:36:23  bynum
 *  add else clause for cin input to an array element
 *
 *  Revision 2.21  2002/02/26 20:37:36  bynum
 *  zero in_typedef flag in non-array typedef
 *
 *  Revision 2.20  2001/11/16 13:45:34  bynum
 *  add code to block the user from calling a non-void function as a void fcn
 *
 *  Revision 2.19  2001/08/01 13:36:48  bynum
 *  add ext_variable to two object type tests
 *
 *  Revision 2.18  2001/07/13 19:28:07  bynum
 *  add globtabs.h include
 *
 *  Revision 2.17  2001/07/05 14:11:37  bynum
 *  allow assignments to ext_variable, move stacksize and ceil to bacicnty.h,
 *  prevent generation of mon init code for ext_monitor, fix psize, vsize
 *  calculations for call-by-reference
 *
 *  Revision 2.16  2001/06/04 16:28:45  bynum
 *  add switch_level increment to switch_hdr rule
 *
 *  Revision 2.15  2000/08/03 20:56:20  bynum
 *  remove writetab.h include
 *
 *  Revision 2.14  2000/06/02 19:28:06  bynum
 *  add warning msg when fcn type defaults to int, block non-void calls
 *  in a cobegin block
 *
 *  Revision 2.13  1999/07/06 15:23:08  bynum
 *  remove extraneous ';' from for_expr_list production, add
 *  ints type to the two productions for receive call
 *
 *  Revision 2.12  1998/11/26 22:46:02  bynum
 *  turn off in_typedef flag at the end of typedef rule
 *
 *  Revision 2.11  1998/10/22 11:27:58  bynum
 *  add init of semaphore and binary sem at declaration
 *
 *  Revision 2.10  1998/08/23 17:32:39  bynum
 *  add productions and code to handle multiple case labels in
 *  the switch statement
 *
 *  Revision 2.9  1997/12/16 19:30:21  bynum
 *  fix two misnumbered non-terminals in two rules
 *
 *  Revision 2.8  1997/11/19 14:18:13  bynum
 *  add empty case to compound_stmt rule
 *
 * Revision 2.7  1997/11/12  18:00:35  bynum
 * make sure EXITMON is emitted before processing returns at
 * function exit
 *
 * Revision 2.6  1997/11/03  20:08:55  bynum
 * add fwd declarations of process_break, process_continues, process_returns
 * (AIX wants them)
 *
 *
 * Revision 2.5  1997/10/21  06:33:14  bynum
 * change sprintf_cnt and sscanf_cnt to varargs_cnt
 *
 * Revision 2.4  1997/10/19  06:52:21  bynum
 * fix int() typecast rule, change the way send, broadcast, and sprintf
 * calls are incorporated into grammar
 *
 * Revision 2.3  1997/09/04  10:52:04  bynum
 * add sscanf, sprintf
 *
 * Revision 2.2  1997/07/25  12:40:54  bynum
 * add in_typedef flag to keep typedefs from being added to stackframe size,
 * fix array elref field handling, make tab[].adr field reflect byte size
 *
 * Revision 2.1  1997/07/10  17:23:55  bynum
 * move yyerror() to ../lib/computils.c, fix parmct error
 *
 * Revision 2.0  1997/07/02  13:05:50  bynum
 * make main() optional, add extern procs, monitors and variables
 *
 * Revision 1.18  1997/06/20  10:02:34  bynum
 * add send, receive, broadcast, int() typecast
 *
 * Revision 1.17  1997/06/17  05:25:51  bynum
 * add 'emit_push_addr' macro, make main() a mainproc object
 *
 * Revision 1.16  1997/06/02  06:56:43  bynum
 * add string type
 *
 * Revision 1.15  1997/05/13  10:15:10  bynum
 * fix break, continue, switch nesting, correct yyerror output
 *
 * Revision 1.14  1997/04/01  12:43:05  bynum
 * use 'lasttoken' in yyeror, add 'null_stmt' rule, repair 'atomic'
 *
 * Revision 1.13  1997/03/25  14:46:47  bynum
 * incorporate name changes in the include directories, add prototypes
 * to silence gcc -Wall complaints
 *
 * Revision 1.12  1997/02/04  08:27:35  bynum
 * remove yyin again, fix yytext output in yyerror
 *
 * Revision 1.11  1997/02/04  07:01:09  bynum
 * switch to FLEX
 *
 * Revision 1.10  1996/05/10  15:03:24  bynum
 * fix assignment in a const declaration
 *
 * Revision 1.9  1996/03/07  09:20:14  bynum
 * remove yyin, yyout declarations
 *
 * Revision 1.8  1996/03/06  13:54:09  bynum
 * add extern to yyin, yyout declarations
 *
 * Revision 1.7  1995/09/19  14:49:48  bynum
 * remove 'comp_date' declaration, change monintor init so
 * RET_MONINIT is emitted last\
 *
 * Revision 1.6  1995/09/07  14:23:45  bynum
 * change to use libba.a library, change includes to conform to
 * new include files, remove definition of 'fatal'
 *
 * Revision 1.5  1995/09/06  13:54:23  bynum
 * add and correct code for 'const', assignment-in-declaration,
 * and 'typedef'
 *
 * Revision 1.4  1995/09/05  14:24:27  bynum
 * add code to handle multple 'break', 'continue', 'case', and 'return'
 * statements, add code to handle recursion in 'for' and 'switch' statments,
 * add ++, --, cout, and cin C++ I/O. Fix var_init for "assignment var
 * declarations" in a monitor
 *
 * Revision 1.3  1995/08/26  16:45:59  bynum
 * add 'break' and 'continue' code, separate 'cobegin' from iteration
 * statements
 *
 * Revision 1.2  1995/08/26  11:09:57  bynum
 * implement 'for' loop, C++ output stream semantics, function & VOID
 * function calls, add 'lastident' FIFO string buffer calls
 *
 * Revision 1.1  1995/08/24  10:50:04  bynum
 * Initial revision
 *
 *
 */
