   /* BenAri external declarations for routines to write the tables */
#include "../include/bacicnty.h"

extern void write_code(FILE *fl, ORDER code[], int last_code);
   /* used by all BACI programs to write the code[] array */

extern void  write_tab(FILE *f, TAB_STRUCT tab[], int last_tab);
   /* used by all BACI programs other than two compilers to write    */
   /*   the tab[] array                                              */

extern void  write_btab(FILE *f, BTAB_STRUCT btab[], int last_btab);
   /* used by all BACI programs other than the two compilers  */
   /*  to write the btab[] array                              */

extern void write_atab(FILE *f, ATAB_STRUCT atab[], int last_atab);
   /* used by all BACI programs to write the atab[] array */

extern void write_stab(FILE *f, char stab[], int stab_size);
   /* used by all BACI programs to write the stab[] array */

extern void write_dbg(FILE *f, PCDEBUG dbg[], int last_dbg);
   /* used by all BACI programs to write the dbg[] array */

extern void write_infile(FILE *f, InputFile infile[], int last_infile);
   /* used by all BACI programs to write the infile[] array */

  
/*
 *
 *  $Log: writetab.h,v $
 *  Revision 1.5  2000/08/03 21:00:00  bynum
 *  remove write_identifier_table and write_pcode function prototypes
 *
 *  Revision 1.4  2000/07/28 20:08:13  bynum
 *  fix write_dbg function prototype
 *
 *  Revision 1.3  2000/07/28 19:46:06  bynum
 *  mirror changes made in writetab.c file, add commenting to function
 *  prototypes
 *
 *  Revision 1.2  1997/10/24 07:24:36  bynum
 *  Borland C++ 3.0 in DOS can't find bacicnty.h unless ../include is added
 *
 * Revision 1.1  1995/09/07  14:19:53  bynum
 * Initial revision
 *
 *
 */

